commit c1c8bf6e896281d88402b7cb07ed5a418f59a48b
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 27 07:55:12 2022 -0500

    bumped changelog version

commit f5fb1e1532979fb0f1519a00be341fe8771cd802
Merge: 7ebd960 995ce07
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 27 07:53:11 2022 -0500

    Merge tag '11'
    
    11

commit 995ce07d4559460b1060991ada7bca1482e4271b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jan 21 19:46:49 2022 -0500

    add is_init likely/unlikely markers

commit c9d1abcd7e1cccd65026fab89206306bbb4d1d3d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jan 21 19:41:53 2022 -0500

    explicitly mark fatal error conditions unlikely

commit 8f0b252c33dac776c8100859fd888568d900d849
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jan 21 19:02:35 2022 -0500

    mark more out-of-memory conditions as unlikely

commit 3cffc1e1af3c7d33d4f71fdc1513d0b71c728ed9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jan 21 18:21:38 2022 -0500

    treat zero size malloc as unlikely
    
    Calls to malloc with a zero size are extremely rare relative to normal
    usage of the API. It's generally only done by inefficient C code with
    open coded dynamic array implementations where they aren't handling zero
    size as a special case for their usage of malloc/realloc. Efficient code
    wouldn't be making these allocations. It doesn't make sense to optimize
    for the performance of rare edge cases caused by inefficient code.

commit ae2524bf8887beace8034a9207bcb5556acbacd9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jan 21 16:24:14 2022 -0500

    ignore environment for test Makefile variables

commit e28addda1921eccff4c15fadf16342eb5c332eb6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jan 21 15:07:13 2022 -0500

    add back gitignore entries

commit 9d89712386c8a963fcaca1125c819483dd2035db
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jan 21 15:06:29 2022 -0500

    remove extra newline

commit 84eadd8568c95698000338c7ec7cd38ff006f59b
Author: jvoisin <julien.voisin@dustri.org>
Date:   Fri Jan 21 20:47:21 2022 +0100

    Move memory corruption tests up a directory

commit 0bbcc5d61040c474d6ef14f011ce0b39ef45777e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 19 16:42:12 2022 -0500

    malloc.c was renamed to h_malloc.c

commit 3fa30842ed6a1d4867a18afbd0c6f049d502c1cc
Author: jvoisin <julien.voisin@dustri.org>
Date:   Mon Jan 17 22:16:45 2022 +0100

    Use $(MAKE) instead of make in Makefiles
    
    This will pass the correct flags to the make
    invocations.

commit b3d78bd5f6d8232655f1f824da7453d3e7f53fbb
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 21:02:17 2022 -0500

    use static const for local constants

commit 8d61e632746395fe892f1d7ad2f02428f6d8726e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 20:50:49 2022 -0500

    add comment about special small size classes

commit 422ee78b3eb6066790a87166a899b0f18e7dc1d9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 16:57:22 2022 -0500

    reorganize pages.h header

commit 3e312695e1e3fe4b2ed405cbb0b1a2844c1a65fe
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 16:28:24 2022 -0500

    document clz64/log2u64 not being able to handle 0

commit 81cf2f27a07439f8a5598f5e8673a76aadfca462
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 14:05:59 2022 -0500

    calculate slab size class instead of array loop

commit d8cb2d9f7a1f132e1c45d6578f3f4d124ec0ebef
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 15:39:59 2022 -0500

    use consistent wrappers around clz/ffs

commit 86f9c739ee88f47c24b7e3c93e94381e88947f6a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 15:01:51 2022 -0500

    define constant for u64 bit width

commit 536f85253853922095819325ce20adc4fd24e4e8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 14:41:46 2022 -0500

    reuse a single size alignment implementation

commit e814cf4f5c459d0e1f883085e7d6763d05e1bfa7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 12:18:00 2022 -0500

    enable linking optimization for GNU linker

commit 705211ef496866cd32f5afb5213af7e8beee3d9c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 11:50:55 2022 -0500

    define UBSan flags for SHARED_FLAGS to reuse it

commit 189d3362d5d0cc87f6b9daf3a4c5a9b921883a8c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 16 11:48:01 2022 -0500

    enable sized deallocation ABI for consistency

commit 7ebd9604f39159b81ffb3dc3b260fe7490ed4b66
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 11:24:06 2022 -0500

    bumped changelog version

commit 6f93aff1ccfb97ace1bf04d6b277aa6eb4d937b9
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 11:21:00 2022 -0500

    legacy

commit b70c622e2ed19220c68b7819a2d615a418a5e0d8
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 10:43:33 2022 -0500

    legacy

commit 6e78118ade09e4b8ce3138f5177615f1677a4544
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 10:40:33 2022 -0500

    legacy

commit c9bb58650052c3b6ce0a4620d5b557503f6e665e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 10:30:30 2022 -0500

    bumped changelog version

commit 4107d703f640c04fbcb208014d1fc419a03c1a8a
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 10:12:45 2022 -0500

    legacy

commit e6c81b9e384489afcbb73129c0e1e906bfec526a
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 09:35:56 2022 -0500

    bumped changelog version

commit 170631407dc5edbf1f1b5a80e6382c02834e425b
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 09:26:06 2022 -0500

    bumped changelog version

commit 0a05dfb27e6280136d29f265b32740923faf5a66
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 09:24:45 2022 -0500

    legacy

commit 470c8521ff624e38ca37d6019377bc86ed806968
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 09:06:31 2022 -0500

    bumped changelog version

commit ab02868f921b873870c67b3ae030537b49b1d316
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 09:04:36 2022 -0500

    update for Hardened Malloc Light

commit 949b4c7e8596181cfbde03d0de4d9f2df7d8c961
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 09:03:11 2022 -0500

    refactoring

commit 9141f1f062efedeb4d0cdf0319aa560ec6d8c879
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 09:01:34 2022 -0500

    renamed:    debian/hardened-malloc-kicksecure-enable.install -> debian/hardened-malloc-light-enable.install
    renamed:    debian/hardened-malloc-kicksecure-enable.postinst -> debian/hardened-malloc-light-enable.postinst
    renamed:    debian/hardened-malloc-kicksecure-enable.prerm -> debian/hardened-malloc-light-enable.prerm

commit 36f131f2caaa20e222cea5ba29b019d884f7ee32
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 09:00:04 2022 -0500

    rename package hardened-malloc-kicksecure-enable to hardened-malloc-light-enable

commit 2dc1f8d668f2c647ade166b125f566838660e0ed
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 08:53:43 2022 -0500

    legacy

commit 1d8ce334120804ee5d33ad3c2dc38c3c77032b06
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 08:27:12 2022 -0500

    use new upstream supported VARIANT=light
    
    (Instead of Kicksecure specific configuration `CONFIG_SLAB_QUARANTINE_RANDOM_LENGTH=0 CONFIG_SLAB_QUARANTINE_QUEUE_LENGTH=0 CONFIG_GUARD_SLABS_INTERVAL=8`,
    which has now been dropped.)

commit 4da35617671ab959dcb9310d05f5c5a45980bca3
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 08:05:01 2022 -0500

    bumped changelog version

commit 0b8d0c02031b3283f6f30896d92452faa294b973
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 15 08:02:55 2022 -0500

    package build fix for upstream version 10

commit ac7538937149f3590a71eafc5ca81dd545eb89eb
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Jan 14 11:23:49 2022 -0500

    bumped changelog version

commit e2bcf4a35633c7d9d5a7ef4c4a09e57447b0b16d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jan 13 14:51:22 2022 -0500

    stop silencing constant logical operand warning
    
    This was resolved by 3696f071a4a136edc9d2baea6ab5fbbd33ced371.

commit d470ae56a58fa3c31b519747c4983036ec15d8fa
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jan 13 14:48:56 2022 -0500

    switch Android build to C17 from C11

commit 42b097f3b04bd791c9d525ee332e44fdb5faec4c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jan 13 14:25:41 2022 -0500

    CONFIG_SEAL_METADATA is regularly tested now

commit b9d66ce4dd654e079b0d5d00a3e6bc5a6102751d
Merge: becde94 17891d7
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 13 08:41:38 2022 -0500

    Merge tag '10'
    
    10

commit 17891d743e2ae7f5c8daf92328da74cfaf40ebca
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 12 10:20:47 2022 -0500

    switch from c11 to c17 standard

commit efd71e70c7213d092a9fa3634972cc1f577944ba
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 12 08:58:00 2022 -0500

    update documentation based on light configuration

commit a6d27848af0ae0a9305cac8ad24a8bcefdabb9a1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 12 08:44:39 2022 -0500

    wrap overly long line

commit 110126d7f0f6fc6dca444fd436d0858632463f33
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 12 08:43:28 2022 -0500

    README: fix path to configuration templates

commit a2bdb4da277035306d1814a4eb9b43694ecf17f5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 12 08:41:21 2022 -0500

    update gitignore for renamed / added tests

commit 0c0561e563d64ef9d9fda35f5c8f9f4620aca3f7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 12 08:41:12 2022 -0500

    update gitignore for config template system

commit 5a577e9ee06e0995902db6ad5fd925ad8828fd35
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 12 08:38:33 2022 -0500

    document configuration template system

commit b3372e157645d3bdb441927f9c3b8220aae6b428
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 9 11:08:56 2022 -0500

    add configuration template system

commit 052b7568408b035a3676f35ac78263606385dbdd
Author: jvoisin <julien.voisin@dustri.org>
Date:   Tue Jan 4 18:39:49 2022 +0100

    Fix two warnings

commit becde94f01af7df335e477f89a869782eb399ad1
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 6 15:26:00 2022 -0500

    bumped changelog version

commit c921c71fe2d0e43dd154368d14e01a6d6cac87a6
Merge: 14f63b3 c6af50d
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 6 15:25:22 2022 -0500

    Merge tag '9'
    
    9

commit 001eb0687b38b624dd8fb8cd235487b24a2ccc16
Author: jvoisin <julien.voisin@dustri.org>
Date:   Tue Jan 4 17:56:48 2022 +0100

    Fix an unused parameter warning

commit 2a5662948e3c5f67648ce584b40a6280f59afbf7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jan 4 12:10:59 2022 -0500

    rename bitmap manipulation functions

commit d1c39edc9b15cf45b5ea577747197d9188417deb
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jan 4 10:14:41 2022 -0500

    use const for malloc_object_size API

commit aa1746a90d864e313ab8965637cff382c2b10130
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jan 4 10:04:26 2022 -0500

    alloc_size attribute for legacy valloc function

commit f3efc26638e207b4e671c24a7d4a46f827a84d5c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jan 4 09:56:29 2022 -0500

    add malloc attribute where appropriate

commit 78cbb964d441d9b25120be0a34f05f78f10770df
Author: jvoisin <julien.voisin@dustri.org>
Date:   Mon Jan 3 17:14:55 2022 +0100

    Add alloc_size and alloc_align attributes
    
    This should help a bit the compiler to emit better diagnostics and to improve
    the correctness of `__builtin_object_size`.
    
    See https://clang.llvm.org/docs/AttributeReference.html#alloc-size
    and https://clang.llvm.org/docs/AttributeReference.html#alloc-align

commit 36dfed3354c14217ac7f93e1ca5abb53cee7f30d
Author: jvoisin <julien.voisin@dustri.org>
Date:   Tue Jan 4 12:54:25 2022 +0100

    Add aarch64 to the CI

commit 8a500088c661226c7bd47e0c9358df7b1ad60c80
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 21:24:31 2022 -0500

    add missing include for overflow tests

commit c50d06bc6a31f2601ef5302832bcd9776dbd4eb0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 21:23:14 2022 -0500

    comment explaining XOR for 8 byte overflow test

commit 645414cc9f7689ae43f5da935d3f436dc46df716
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 21:20:15 2022 -0500

    add 1 byte overflow tests

commit 13a1f578cb560c358db56cc1e06595f083545e4f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 21:11:31 2022 -0500

    use calculated size for overflow tests
    
    This greatly reduces how much these tests depend on hard-wired knowledge
    about the size classes.

commit acda766e2ccdeedb7a4a634d84089a1ca1f73b8c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 21:07:24 2022 -0500

    fix small allocation canary overwrite test
    
    Overwriting one byte of a canary with 0 has a 1/256 chance of not
    triggering the expected failure.

commit 5f32942263f1aba8feccee05f5d16900fddbd7f0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 17:56:57 2022 -0500

    get rid of canary_value when canaries are disabled

commit 346529574d88cfc82d3b7ba8c29ea97e6c797e3a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 17:55:05 2022 -0500

    check whole allocation for uninit read large test

commit 16c991b8f75374bcfeae4711d3270e743f5988a6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 16:11:03 2022 -0500

    use 256k for large allocation tests

commit 5f59ee393523698cc1823b7ad913ea8fd00087e8
Author: jvoisin <julien.voisin@dustri.org>
Date:   Mon Dec 27 13:17:58 2021 +0100

    Add two tests to check that uninitialized read are zeroed

commit 3696f071a4a136edc9d2baea6ab5fbbd33ced371
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 02:17:04 2022 -0500

    use SLAB_CANARY for conditional checks

commit 7d6663ed80921030a83c5bf82616edcb6350edc4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 01:41:17 2022 -0500

    update copyright notice

commit c6af50d0881c58b5e5d139c96ee446373dac42df
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 01:29:12 2022 -0500

    use unsigned for ffzl definition
    
    This makes more sense and avoids clang tidy conversion warnings.

commit 8ae78237aee18491d488bc7c734e41937c7930f0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 00:54:43 2022 -0500

    avoid unnecessarily mixing 32-bit and 64-bit ints
    
    It's ever so slightly faster to stick to stick to 64-bit arithmetic and
    it avoids clang tidy being unhappy about the implicit widening.

commit 3f8e9d3184bccfd0d75b0498e6c1e21a2c60085a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 00:31:46 2022 -0500

    make MREMAP_MOVE_THRESHOLD into size_t constant
    
    This avoids a clang-tidy warning and is a bit cleaner.

commit 1e526fc36b6310e40bfb44f1b5e0218e557a4935
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jan 3 00:27:49 2022 -0500

    disable incredibly impractical clang-tidy check
    
    bugprone-easily-swappable-parameters is completely impractical for real
    world usage. It's a reasonable thing to consider as part of API design
    but it mostly applies to having APIs taking a lot of parameters. It's
    unreasonable to disallow APIs simply taking 2 integer parameters even as
    a loose guideline.

commit c5be4b1888768738123cd864176b73a51302e50f
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sun Jan 2 13:30:34 2022 +0100

    Fix two mundane clang warnings in the testsuite

commit ffdf7b1ee18e5295fb4c6f67f4ff3c9490a906a5
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sun Jan 2 13:39:42 2022 +0100

    Make the testsuite work for read-after-free
    
    This commit makes the testsuite fail if
    the read-after-free tests are failing, instead
    of simply printing some info.

commit 2d56c1de01ac9ca13fb5aa09b9ce2b8313b17413
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sun Jan 2 13:51:25 2022 +0100

    Fix a couple of mundane typo in the readme

commit 3878f4a5f4105c44e3bf5349cff636b5ba1e0697
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sat Jan 1 17:25:25 2022 +0100

    Don't ignore the return value of the testsuite

commit de7a3b6e5a6b2f2779809f82591f43bc647c9ea0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Jan 1 23:18:52 2022 -0500

    enable sized deallocation for sized deletion test
    
    Clang doesn't currently enable sized deallocation by default like GCC.

commit 9142a9376b9b4d34950a94f49a4d6b7260c408c2
Author: jvoisin <julien.voisin@dustri.org>
Date:   Thu Dec 30 20:07:14 2021 +0100

    Add a bunch of const qualifiers

commit 75e26afdb6f50373414228baa9a8cf07188db197
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Dec 30 19:17:23 2021 -0500

    remove legacy safe_flag check for -fno-plt
    
    This is supported by the minimum versions of the dependencies.

commit cff1d6d4b5715d0f3d59c46fd11b2a3f8686888e
Author: jvoisin <julien.voisin@dustri.org>
Date:   Tue Dec 28 12:27:28 2021 +0100

    Add a test to prove that hardened_malloc handles too-large-to-be-true allocations
    
    This pattern, used by https://github.com/kaist-hacking/HardsHeap,
    uncovered bugs in other memory allocators.

commit 75952581ee2391438b933a4d4021d7f2f4f43724
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sun Dec 26 15:34:37 2021 +0100

    Silence a GCC warning
    
    As suggested in https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66425#c34

commit a84d3f5310987c6de4de0a314abd6d6193af76c4
Author: jvoisin <julien.voisin@dustri.org>
Date:   Thu Dec 23 17:52:35 2021 +0100

    Run the testsuite on musl as well in the CI

commit 0655c1d0249d626e578b795efbac01ef349e6884
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sun Dec 26 23:37:52 2021 +0100

    Add a missing const

commit 2b25c791eed3c3ae61c4cc31ba87731f29b302fa
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sun Dec 26 22:30:36 2021 +0100

    Run the CI every day at 2am UTC
    
    This should help to catch issues in newer versions
    of distributions/packages.

commit e816c545ea19f062ef9935c2876bad04a2985ec0
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sun Dec 26 21:58:19 2021 +0100

    Run the CI in clang

commit 06192ae49943efde3dc3b0970281d900a3189bfb
Author: jvoisin <julien.voisin@dustri.org>
Date:   Sun Dec 26 22:18:40 2021 +0100

    `make clean` is now thorough

commit 4ccd6f16df4054133b4261a803a2305e12ddf3b3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Dec 26 16:24:38 2021 -0500

    always enable C++17
    
    The safe_flag check doesn't work properly for C++ flags with Clang so
    this wasn't getting enabled despite the conditional compilation being
    removed from the code, leading to breaking Clang builds.

commit 9966adbdada3ecb15c7f377fce89686bdae72aca
Author: jvoisin <julien.voisin@dustri.org>
Date:   Thu Dec 23 20:44:45 2021 +0100

    Add another ifdef for GNU extension

commit 769e01fc4bacd4c6b6ffd6bbc36ff913844fa3b7
Author: jvoisin <julien.voisin@dustri.org>
Date:   Thu Dec 23 18:27:18 2021 +0100

    Don't use mallinfo on non-android and non-glibc

commit 460fef456d70d315176c53a908c992444ac23ba1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Nov 23 15:42:29 2021 -0500

    only Android 12 is supported

commit 1a650b0317dfe98a2a7771bd73300003d6cbd6d0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Nov 11 22:17:56 2021 -0500

    update copyright notice

commit fa46a7a85d6eb54284b086550268d66dbf3e1056
Author: Lelmister101 <92394696+Lelmister101@users.noreply.github.com>
Date:   Sun Dec 5 20:18:18 2021 +0530

    small typo fix
    
    “expanded cover” changed to “expanded to cover”

commit d8817417cc099bdf47605a676067a8cf4f95bf23
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Nov 23 15:59:52 2021 -0500

    use compiler extension instead of C11 noreturn
    
    C11 noreturn isn't available in C++.

commit 7106bff27f304d12f771d67b3a51831f7fd7b2d8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Nov 23 15:53:03 2021 -0500

    update required dependencies

commit 1bdbb2d3f7c0aec52d4f2d4f4cb546ff8707c71f
Author: Lelmister101 <92394696+Lelmister101@users.noreply.github.com>
Date:   Tue Nov 23 16:09:03 2021 +0530

    minor typo fix
    
    “entirely independently arenas” changed to “entirely independent arenas”

commit 14f63b3c87e1c38de5ccab20fa4f6717e9b0e506
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Nov 9 14:32:30 2021 -0500

    readme

commit a33d2ca97d119ef657207fc27248db4c3103531f
Author: Thibaut Sautereau <thibaut@sautereau.fr>
Date:   Tue Nov 2 20:22:05 2021 +0100

    Fix CPPFLAGS in test Makefile
    
    In particular, the _GNU_SOURCE feature test macro needs to be set in
    order to correctly define mmap(2) flags such as MAP_ANONYMOUS.
    Otherwise, compilation of some test files fails when CPPFLAGS is not
    defined in the initial user environment, as Make then does not export it
    from the root Makefile to the sub-make.

commit aa94408cc234767dfcf5a807098d21e1745b7d45
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 19 23:52:18 2021 -0400

    fix wording

commit 8f9305df57ca2943e7476d906ec9ebabb8f2ed85
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 8 13:44:28 2021 -0400

    Android 12 is supported

commit cc0a1e173618075fb814f325f24cd2298e6ae5e4
Author: anupritaisno1 <www.anuprita804@gmail.com>
Date:   Wed Aug 18 20:12:14 2021 +0530

    make hardened malloc vendor ramdisk avaiable
    
    Signed-off-by: anupritaisno1 <www.anuprita804@gmail.com>

commit 3b72a4f81011cbebc3532b8b16706756ea29405a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 30 11:05:47 2021 -0400

    set C / C++ standard parameter for clang-tidy

commit e41d37c3de9a7998b6644b61a3dc8e90b2ca9080
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 30 10:57:05 2021 -0400

    remove unnecessary else

commit 23969727d8c6b4581d17edb00dac909931f5dae0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 30 10:55:12 2021 -0400

    disable readability-function-cognitive-complexity

commit 4d30b491e3f63b44220dc275a664a42f64c5a8c0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 30 01:18:36 2021 -0400

    set up dependabot for GitHub Actions

commit 11207a9c98a8093b91f5b45b60da2944eda59fb3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 30 01:09:36 2021 -0400

    add GitHub workflow for building and running tests

commit 801e8d959fdcf426875a5b03ba28bd09b86c4b6b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 30 01:16:10 2021 -0400

    disable mallinfo2 test for old glibc

commit a7984633547e9e5b3006244a4b97c816ac2881d9
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Sep 11 18:43:35 2021 -0400

    bumped changelog version

commit d2728075463dfad4ab2d688b402a58758a353b2d
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Sep 11 16:47:33 2021 -0400

    `Architecture: any` -> `Architecture: amd64`

commit 406d23642762ab9fef8a4cac81816caef26e1aea
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Sep 11 16:32:51 2021 -0400

    readme

commit 8dfea34fc0067d144f98ecac773de7076f786e10
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 5 01:59:45 2021 -0400

    current AOSP stable branch is Android 11 QPR3

commit e6dcc9a528816799d62142df1344efd71a9371db
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Sep 4 11:58:49 2021 -0400

    bumped changelog version

commit 09f2d937e05ea99114258eaf72a75aa247de8279
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Sep 3 06:11:11 2021 -0400

    description

commit 42f74b571d6e8a1288fada047bae25bdbcddc25a
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Aug 22 05:28:39 2021 -0400

    bumped changelog version

commit c77dedbeb06666f4daef5ad51556e2a3f5d59491
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Aug 22 05:21:24 2021 -0400

    LANG=C str_replace

commit 2ebd7b92e9f253227e163101a1f12afdbea9c98e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Aug 17 14:11:23 2021 -0400

    bumped changelog version

commit b57317dbbc285bbe0ad817c2c3b1c9213de70cfe
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Aug 5 16:43:41 2021 -0400

    bumped changelog version

commit a12d0612777546a78fc5c22ebb049459928c2cb1
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Aug 3 12:48:53 2021 -0400

    move /usr/lib/helper-scripts and /usr/lib/curl-scripts to /usr/libexec/helper-scripts as per lintian FHS

commit 2b8b3179827c7515572ac8e95305b09d1bc5ac77
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Aug 3 07:09:25 2021 -0400

    remove `man` workaround /
    remove `export MAN_DISABLE_SECCOMP=1`
    
    since no longer required
    
    Fixed in `man` upstream and in Debian bullseye.
    
    https://savannah.nongnu.org/bugs/index.php?56767
    https://forums.whonix.org/t/hardened-malloc-hardened-memory-allocator/7474/105
    https://forums.whonix.org/t/hardened-malloc-hardened-memory-allocator/7474/109
    https://git.savannah.nongnu.org/cgit/man-db.git/tree/lib/sandbox.c#n142

commit fe80909a10ad629d3417b18146f5b9b5e29ed556
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Aug 3 06:30:21 2021 -0400

    llvm-7-dev -> llvm-11-dev
    
    https://github.com/GrapheneOS/hardened_malloc/issues/89#issuecomment-891720094

commit 1a9832179541615f9bce9a245a903ddd98e97104
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Aug 3 05:48:21 2021 -0400

    bullseye

commit a037d1ad0f3205d2f68768d816405285a83da1e2
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Aug 1 16:32:01 2021 -0400

    bullseye

commit c5ef96a364a914b40decced9f3195e1eedd26e71
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Aug 1 16:24:30 2021 -0400

    readme

commit 4d6456cf5841e040b120f7dd9216cc916f608e45
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Jul 17 14:58:23 2021 -0400

    update libdivide to 5.0.0

commit f12cea0f2f57c32963ca34db21813a48d281b979
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun May 23 14:47:07 2021 -0400

    bumped changelog version

commit d780417209eb3bfe907cb1b1ddb567415882fa3e
Merge: 7bee4a9 27fcfcc
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun May 23 14:28:28 2021 -0400

    Merge tag '8'
    
    8

commit be6dde66f969ef921843abbd9e6281e4087d3889
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri May 21 09:07:28 2021 -0400

    fix missing include for Intel MPK support

commit e0ecacff451912a32a1a63f9d9a8d7f63546cfd8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri May 21 09:00:39 2021 -0400

    drop support for legacy C++ versions

commit 050871122b375f5cb162d302381a330f26cbe2a7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu May 13 19:50:26 2021 -0400

    update non-Android max_map_count recommendation

commit 27fcfccb6722ca5f31be1a30b6fc5d4d8f863e25
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 22:53:20 2021 -0400

    make __GLIBC_PREREQ check for mallinfo2 portable

commit 93a87ce30b3d11587adb2d20107c812815512098
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 21:13:06 2021 -0400

    add new mallinfo2 test to gitignore too

commit da190f1469277710321e37f1bc89abea001aa584
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 21:01:13 2021 -0400

    mark pvalloc error path as unlikely

commit b0f81365a8c3426ee63658bae5aaee8ca73bbc4c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 20:59:04 2021 -0400

    reuse code for aligned allocation API entry points

commit c9820b6e372e2124c96ba4f545bb667df534b376
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 20:41:46 2021 -0400

    mark alloc_aligned_simple error path unlikely

commit f1cdc1e484b594182d6a60b9331abdb8dc541429
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 20:34:18 2021 -0400

    remove disconcerting newline

commit 26b74b87bf38b0a377c622d166caeee61d49de27
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 20:28:37 2021 -0400

    improve code reuse for malloc API entry points

commit 89faba423293235089e05031d0e475edfe5e65e8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 20:19:12 2021 -0400

    set errno in malloc_get_state to match glibc

commit a45dacc57be53d6eae523f826bc2e3bb5657a6be
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 20:07:15 2021 -0400

    add support for glibc mallinfo2

commit a71ab1a2eb3106b80673c046939eec746e97897d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 10:51:52 2021 -0400

    MREMAP_DONTUNMAP may be usable in realloc

commit 96a322bcbe773cfa12881d71d18786ec1f70c619
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 10:32:59 2021 -0400

    raise max_map_count recommendation

commit 92a1e456d2ea4c8d80d6e67f4239786e757ce729
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 05:11:30 2021 -0400

    use normal class region size on x86_64 Android

commit 9706f5a311451f35d183ef55e29893b229b38099
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 03:06:57 2021 -0400

    increase class region size on Android to 2GiB

commit 440489af6737085ad0a630a35262653f1f990239
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 01:05:39 2021 -0400

    purge memory if munmap fails

commit f9a8e7216bdcba5f1f25b9f5e1a3aac665b73329
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 00:39:36 2021 -0400

    purge slab memory even if using MAP_FIXED fails

commit 5c974bdf8209e79dedeab1a4d22286f0bbece8ff
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 12 00:20:03 2021 -0400

    use region quarantine even if MAP_FIXED call fails
    
    This is a more sensible way of handling an out-of-memory failure in this
    edge case. It doesn't matter much in practice.

commit 2335f56713dbfe0f021fd75319c0ce8ca9a5532b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon May 10 07:04:50 2021 -0400

    add wrapper function for getting slot count

commit 13a3aa16d0cb70e67d58449e8742327e3ace0927
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri May 7 04:23:49 2021 -0400

    improve naming of adjust_size_for_canaries

commit 8bfa1a7dd50ec8ffb80ae64309cedf27f86ad583
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat May 1 22:10:20 2021 -0400

    use 1 slot for all extended size classes
    
    This reduces memory usage and improves security in combination with the
    guard slab feature.

commit 7bee4a9c3df727ee35ea3f510aae9f6f58934834
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Apr 10 17:23:03 2021 -0400

    bumped changelog version

commit e5190f01653a6977a971637a1941cb469c055ba0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Mar 31 12:12:49 2021 -0400

    avoid unused variable for some configurations

commit 1b848cfdce9076e13f7551f94e68aacc28455949
Merge: 9b02c5e 1d15d34
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Apr 10 17:00:16 2021 -0400

    Merge tag '7'
    
    7

commit 39526453181babac2ba2ef3d09a406f2b7ff0305
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Mar 31 12:12:49 2021 -0400

    avoid unused variable for some configurations

commit 1d15d34c7ee9d85cff61da2ef6be78fa108230d9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 22 14:19:02 2021 -0400

    return errors from memory_set_name too

commit 29ffcdf810d70bfdd94d67441e54d1ebe00e5712
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 22 13:59:16 2021 -0400

    portable error reporting for memory API

commit f773a96b59b28c8791e3fae0ff7f68bab176a6d8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 22 12:25:22 2021 -0400

    remove unnecessary sys/mman.h include

commit b84af9b499891f250637eabb0837f3ae31be353e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 22 12:24:26 2021 -0400

    add wrapper for madvise

commit 73b78a8adb14b36dde370e1ebd8878eef893b40f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Mar 21 19:29:46 2021 -0400

    document madvise for malloc_trim of quarantines

commit e77ffa76d9ec0d05d73a2776430d9092957e90c2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Mar 21 19:27:48 2021 -0400

    add initial malloc_trim slab quarantine purging
    
    This currently only purges the quarantines for extended size classes.

commit 86b0b3e452dedad7357e32827494e271ffb465a9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Mar 21 18:09:02 2021 -0400

    fix !CONFIG_EXTENDED_SIZE_CLASSES configuration

commit 7b03b5c629a918b630db9aee6ca431e02ff9c908
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Mar 18 07:35:38 2021 -0400

    update README for region quarantine change

commit db21ecd529eac3c92b1a459f9248b21e18619c5b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Mar 18 06:27:46 2021 -0400

    use longer default region quarantine random array

commit 9b02c5e89ff78ad75320a69078182c17870bb469
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Mar 17 11:31:34 2021 -0400

    bumped changelog version

commit 4b6afd85b1bce3c701644893411b6d628f85af33
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Mar 17 09:45:15 2021 -0400

    copyright

commit ee55acf11645847b16cce889819df0caa244dc7b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Mar 9 02:38:16 2021 -0500

    update libdivide to 4.0.0

commit a3b4c163eb716244f2cfa6f91039720def5a4200
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Mar 5 00:35:10 2021 -0500

    drop unused header

commit 325b82f1bde81f2d9d6e6a076abc69225af215cc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 1 16:52:08 2021 -0500

    update to Android qpr2 branch as minimum

commit 80f5ba11a6189355e02c616f193a1253aae2ab7f
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Feb 21 11:31:03 2021 -0500

    bumped changelog version

commit 2c1f6654df947b209c577ae368e38ff0f51294bc
Merge: 7220570 29b0964
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Feb 21 11:30:24 2021 -0500

    Merge tag '6'
    
    6

commit ddd14bc4219898abd647f96da9dededed249e192
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Feb 16 17:18:06 2021 -0500

    avoid type comparison warning on some platforms

commit 29b09648d6ad0a01ffaf8ff84b30084ff8bc921a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Feb 16 08:18:44 2021 -0500

    avoid undefined clz and shift in edge cases
    
    This is triggered when get_large_size_class is called with a size in the
    range [1,4]. This can occur with aligned_alloc(8192, size). In practice,
    it doesn't appear to cause any harm, but we shouldn't have any undefined
    behavior for well-defined usage of the API. It also occurs if the caller
    passes a pointer outside the slab region to free_sized but the expected
    size is in the range [1,4]. That usage of free_sized is already going to
    be considered undefined, but we should avoid undefined behavior in the
    caller from triggering more undefined behavior when it's avoidable.

commit 1984cb3b3d749f2d99aae05602d5534dd33f8e88
Author: Thibaut Sautereau <thibaut.sautereau@ssi.gouv.fr>
Date:   Wed Feb 10 09:55:09 2021 +0100

    malloc_object_size: avoid fault for invalid region
    
    It's the region pointer that can be NULL here, and p was checked at the
    beginning of the function.

commit 76860c72e1003f12e08dae067b4d7c97c070c208
Author: Thibaut Sautereau <thibaut.sautereau@ssi.gouv.fr>
Date:   Wed Feb 10 09:25:55 2021 +0100

    malloc_usable_size: clean abort on invalid region
    
    It's the region pointer that can be NULL here, and p was checked at the
    beginning of the function. Also fix the test accordingly.

commit 722057082964dc452d89aefbe5344692e8b6eb8f
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 6 06:29:17 2021 -0500

    bumped changelog version

commit 268bee706a1d035d6c29e4beabc21514cd7b9129
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 6 06:27:53 2021 -0500

    readme

commit 33358e476f38163e4122ddf1a3da9d6a93a1926b
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Jan 8 23:51:35 2021 -0500

    bumped changelog version

commit 088581a4dda232778029d5dcdb68dd644cf2de4f
Merge: d3e1af0 5c8b686
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Jan 8 23:32:45 2021 -0500

    Merge tag '5'
    
    5

commit 5c8b6863708ebbee4bc68e0dc34e727d2f2dbfc1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 6 20:38:40 2021 -0500

    update copyright notice

commit 52755632528d819147985bfe15a11849287f1634
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 6 00:12:17 2021 -0500

    fix C++ sized deallocation check false positive
    
    This is a compatibility issue triggered when both slab canaries and the
    C++ allocator overloads providing sized deallocation checks are enabled.
    
    The boundary where slab allocations are turned into large allocations
    due to not having room for the canary in the largest slab allocation
    size class triggers a false positive in the sized deallocation check.

commit d3e1af06e7b02c678e3023f5ac36c02e2b631b80
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Dec 20 07:56:30 2020 -0500

    bumped changelog version

commit 8c619ce5f6ff168b7775b1449517f2a69def753d
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Dec 20 07:51:54 2020 -0500

    `MAN_DISABLE_SECCOMP=1` man seccomp workaround
    
    https://forums.whonix.org/t/hardened-malloc-hardened-memory-allocator/7474/132

commit a19b5b42e88000e7b82d5f46ca206828a6abfb9f
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Tue Dec 15 06:52:40 2020 -0500

    bumped changelog version

commit ec912a38ea97be04dbc3c628eacf0e6acfa56c2a
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Tue Dec 15 04:44:32 2020 -0500

    conditional

commit 852af90aa81ebc29df69fcbbc29fed387ad2ccc2
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Tue Dec 15 04:43:34 2020 -0500

    comment

commit 98b00ee79094a3b4213797e3d49ba26de36b4b5b
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Tue Dec 15 04:38:18 2020 -0500

    hardened-malloc-kicksecure: add `export MAN_DISABLE_SECCOMP=1`
    
    /etc/X11/Xsession.d/50hardened-malloc
    
    Thanks to @madaidan for the problem solution!
    
    https://forums.whonix.org/t/hardened-malloc-hardened-memory-allocator/7474/125

commit e9d9f70ad48e428a8da10351cc8006ddcf2bfab0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Dec 7 18:14:25 2020 -0500

    update supported Android 11 branch

commit 9437c07df1f690617e1a0b0f7e498c4a8398b6de
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Nov 13 08:55:08 2020 -0500

    bumped changelog version

commit ef327be1fa3deb465ec367dc454922fa7dd11da4
Merge: b7ccfb2 10c5d61
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Nov 13 08:54:53 2020 -0500

    Merge tag '4'
    
    4

commit 10c5d61187badae1666200c32584fa76050bb031
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Nov 10 14:14:08 2020 -0500

    work around glibc bug in mallinfo test

commit b90f650153c677fc3a95f80f747987a828d3bdf3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Nov 10 13:53:32 2020 -0500

    fix sized deallocation check with large sizes
    
    The CONFIG_CXX_ALLOCATOR feature enables sanity checks for sized
    deallocation and this wasn't updated to handle the introduction of
    performing size class rounding for large sizes.

commit 8d0314295ebf2a84604aeb7eef3b759daef92f1a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 19 07:25:15 2020 -0400

    support Android's logging system for fatal_error

commit b7ccfb2da09eb1fd5a9af216112afcdc03c312e6
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Oct 8 13:39:32 2020 -0400

    bumped changelog version

commit cd9577830903ff89826cf30aca79010f0b2ec4bf
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Oct 8 13:39:17 2020 -0400

    ship `/etc/sysctl.d/hardened_malloc.conf` with `vm.max_map_count = 524240`
    
    https://github.com/GrapheneOS/hardened_malloc#traditional-linux-based-operating-systems
    
    Thanks to @madaidan for the suggestion!
    
    https://forums.whonix.org/t/hardened-malloc-hardened-memory-allocator/7474/93

commit 4c790044e07e14e23a0fe3c9583023c076fbd5dc
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Oct 8 05:40:09 2020 -0400

    bumped changelog version

commit 67e600b87fbb9829986203031d428b142ed2d759
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Oct 8 05:40:08 2020 -0400

    readme

commit 82ea528b1cbfe29c192d8f8474e1dcd3cec7a404
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Oct 8 04:57:57 2020 -0400

    implement hardened-malloc-kicksecure-enable package
    
    https://forums.whonix.org/t/hardened-malloc-hardened-memory-allocator/7474/82

commit 310e270063fd0edcb699ece2f84db4aaaf74e06d
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Oct 7 11:41:49 2020 -0400

    bumped changelog version

commit 7e5dd71596418ce91c5f9b53f0aa8abf138f3367
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Oct 7 11:30:31 2020 -0400

    CONFIG_NATIVE=false
    
    https://forums.whonix.org/t/hardened-malloc-hardened-memory-allocator/7474/89

commit 19ff229bcb0ee959c5e9b115e47e60e0a734d597
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Oct 7 11:30:15 2020 -0400

    refactoring

commit 1cdddf46b00f3583a9a807d278c6c371afc7324d
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Oct 7 10:13:43 2020 -0400

    bumped changelog version

commit d0a74274afe4dad047eb5892f278ec742e8b7a0b
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Oct 7 10:13:43 2020 -0400

    readme

commit cee13a3981b68085300fdcc01043e65025dc715a
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Oct 7 10:12:56 2020 -0400

    fix installation path
    
    https://forums.whonix.org/t/hardened-malloc-hardened-memory-allocator/7474/84

commit d684cfacaa09190d8f3ee01c844a45c448f48828
Merge: 4a86834 d74b504
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Oct 7 10:00:03 2020 -0400

    Merge remote-tracking branch 'github/master'

commit d74b50482b04fa1d6b5128e627d81dd7f67d00b1
Merge: 4a86834 5564188
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Oct 7 13:59:07 2020 +0000

    Merge pull request #1 from madaidan/kicksecure
    
    Create libhardened_malloc_kicksecure.so

commit 556418894fef1eb542b668dd9b88fe6b5e2b9f4f
Author: madaidan <50278627+madaidan@users.noreply.github.com>
Date:   Wed Oct 7 13:28:36 2020 +0000

    Install libhardened_malloc_kicksecure.so

commit 73b1659fdcb40b6e4e7b607a4c2745d1ced68080
Author: madaidan <50278627+madaidan@users.noreply.github.com>
Date:   Wed Oct 7 13:28:13 2020 +0000

    Create libhardened_malloc.so_kicksecure

commit b072022022b7d6c3f29001560603479ae6ba883c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 6 17:34:35 2020 -0400

    perform init sanity checks before MPK unsealing

commit 2bb1c39d31aff68a58fb5be2e0bc7c6168d37acd
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 6 17:32:25 2020 -0400

    add MPK support for stats retrieval functions

commit 0bf18b7c266e7c1ee05f64916ac5c3aada2b0936
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 3 15:10:07 2020 -0400

    optimize malloc_usable_size enforce_init

commit 178d4f320f0a0798d066fec12c196963a7ee608c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 2 15:04:41 2020 -0400

    harden checks for uninitialized usage

commit 4a86834f5d3cce55593cef772de8d4d20120b6b7
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sat Sep 19 09:45:08 2020 -0400

    bumped changelog version

commit b9ebf47c7cfd6ca0ba29c25181789dd383a73f1b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Sep 19 09:40:41 2020 -0400

    explicitly use python3 to run tests

commit 1af409e12029c6328cb5e095adc1f78a756f17b9
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sat Sep 19 09:26:19 2020 -0400

    bumped changelog version

commit 168907c1c83247ab1fb27b953726ac2e223bc365
Merge: 0188e9b e58aa20
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sat Sep 19 09:20:32 2020 -0400

    Merge branch '3test'

commit e58aa20467a8e6251c873f76d46407e70bacc6c9
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sat Sep 19 09:09:21 2020 -0400

    disable tests
    
    Tests failing inside (cowbuilder) chroot.
    
    https://github.com/GrapheneOS/hardened_malloc/issues/119
    
    Test failing on travis CI.
    
    https://api.travis-ci.com/v3/job/387405272/log.txt

commit 650b7e3f256152550d723a0c318cda30f687876a
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sat Sep 19 08:57:59 2020 -0400

    comment: Tests failing inside (cowbuilder) chroot.
    
    https://github.com/GrapheneOS/hardened_malloc/issues/119

commit 02f826d41c66776609c7d062451ea1750ae52e29
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sat Sep 19 08:54:44 2020 -0400

    Intentionally dropping: -fstack-protector-strong -Wformat -Werror=format-security
    Unintentionally dropping: -fdebug-prefix-map=
    
    by setting `CFLAGS =`
    
    https://github.com/GrapheneOS/hardened_malloc/issues/120#issuecomment-694933692

commit 1d14b7f49fa3b71d6fc6975286580e32da611171
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sat Sep 19 08:26:15 2020 -0400

    disable `export DEB_BUILD_MAINT_OPTIONS = hardening=+all`
    
    Cannot set. Causes tests to fail. Also not required since upstream already
    sets hardening options in upstream Makefile.
    
    https://github.com/GrapheneOS/hardened_malloc/issues/120#issuecomment-694933692

commit 8906c0941a8c0a3c7bcb1ae3348c7baa93565871
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 18 11:38:06 2020 -0400

    improve mallinfo test

commit 5257b19bd45cc6ee8fcb76bb2ab32fb41aa634cb
Merge: cdaaa0c cc77a84
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 09:47:11 2020 -0400

    Merge branch 'travis-test' into 3test

commit cc77a84352aff25466bb1d0b0a38d64471fa139f
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 09:44:17 2020 -0400

    travis

commit 0d1da4a342603addbc427f71e8da6bf49fecf2af
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 09:14:05 2020 -0400

    travis

commit 0070ac3a437a3160ae36fa98ebbf1bbf517b490d
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 09:11:07 2020 -0400

    travis

commit 4f0520fd83b8093450f4d0b7562492965e69924b
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 09:00:22 2020 -0400

    travis

commit 286070a9baff3108ff341cf6c06b2931eafff31c
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 08:47:52 2020 -0400

    travis

commit 0eba7c1439d390595f3f48df84d5b1442c4dd5ec
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 08:43:40 2020 -0400

    Add /.travis.yml to extend-diff-ignore in debian/source/options.

commit 951e8c8e3c6d69be1f7aa9c412934518ab17f14f
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 08:38:53 2020 -0400

    Add .travis.yml from <http://travis.debian.net>

commit cdaaa0c4f495a1ff39b1c7097e64631fa2ffb890
Merge: 0188e9b b4bbd09
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Sep 18 06:14:40 2020 -0400

    Merge tag '3' into 3test
    
    3

commit 59e174eee083af31363cd9da88ef3aac2d708ff8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 17:44:01 2020 -0400

    update stats documentation

commit 483b1d7b8b8832b85c657d16863d2c7d19bc5d07
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 17:40:19 2020 -0400

    empty malloc_info output when stats are disabled

commit 96eca21ac5fc49bb348e97f8f0347fa458dbb212
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 17:37:49 2020 -0400

    remove thread_local macro workaround glibc < 2.28

commit 022b64791ea8096c5c91bbad67c0debcf72604f9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 17:23:13 2020 -0400

    whitespace fixes

commit b4bbd09f07772e648ca05684a3b462e3074f09fe
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 16:54:50 2020 -0400

    change label for quarantined large allocations

commit a88305c01b409703e50c98a1ffa4f58c3ff6d161
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 16:51:16 2020 -0400

    support disabling region quarantine

commit 85c5c3736c396702ac5ce3aed7f18c0498c7334f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 16:29:13 2020 -0400

    add stats tracking to special large realloc paths

commit 96a9bcf3a1246bb1e1fabc7a990d374e6959eae3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 16:20:05 2020 -0400

    move deprecated glibc extensions to the bottom

commit 41fb89517ab13a4530b13f7e0f635ef4021364a1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 16:09:45 2020 -0400

    simplify malloc_info code

commit 50e0f1334c3e08bf253316557a8fc2a3651cf753
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 16:07:10 2020 -0400

    add is_init check to malloc_info

commit 9fb2791af21b36f2ecea67ecb5d27d3a85c7b9d9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 17 16:00:03 2020 -0400

    add is_init check to h_mallinfo_arena_info

commit 8974af86d12f7e29b54b5090133ab3d7eea0e519
Author: anupritaisno1 <www.anuprita804@gmail.com>
Date:   Tue Sep 15 01:33:53 2020 +0000

    hardened malloc: iterate -> malloc_iterate
    
    Signed-off-by: anupritaisno1 <www.anuprita804@gmail.com>

commit d203d6c4456e1f88edef7136a99be1ad7ef7cfdd
Author: anupritaisno1 <www.anuprita804@gmail.com>
Date:   Mon Sep 14 09:10:27 2020 +0000

    Android.bp: export hardened malloc headers
    
    Signed-off-by: anupritaisno1 <www.anuprita804@gmail.com>

commit 9f5e1f6eb9cff75ca975842eac549f31204d1019
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Sep 14 05:57:39 2020 -0400

    master is only going to support Android 11

commit 1cba2544525f048e25f0a540d726dbfaa4359489
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Sep 14 05:52:53 2020 -0400

    move external API to include directory

commit 730f148647302c9ae542df4c2f606cf0a00b33e8
Author: anupritaisno1 <www.anuprita804@gmail.com>
Date:   Sun Sep 13 08:56:39 2020 +0000

    Android.bp: make hardened malloc ramdisk available
    
    Signed-off-by: anupritaisno1 <www.anuprita804@gmail.com>

commit dd7291ebfeedfa475e2f27079a2ed454245fd810
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 5 18:10:53 2020 -0400

    better wording for page size mismatch error

commit bcb93cab639176078b881911b7f7686c759f6052
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 4 17:22:03 2020 -0400

    avoid an ifdef

commit f214bd541a8f03cc8cf5faeed07692bff11d9f9a
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Wed Jun 17 19:00:32 2020 -0700

    added check for if small allocations are free

commit 7804e263e9e2eac91f71b211e7c1e451b5fb279a
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Wed Jun 17 18:59:44 2020 -0700

    added tests for if malloc_object_size small allocations are free

commit de3fb50dcc2c40ca108f8946e84538833db462c9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jun 17 16:39:50 2020 -0400

    tests: make no-optimize attribute Clang compatible

commit b404d6da6e3c1882b52dc76db7915265c34e079e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jun 17 16:27:59 2020 -0400

    fix out-of-memory check in offset test

commit c9c7dca4984fd1da03c9298b6594118613ee95d2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jun 17 16:26:01 2020 -0400

    use size_t in offset test to fix warning

commit dcc80a01dbcfde0105832cb0c94f74a4d26fe461
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jun 16 11:10:13 2020 -0400

    android10-qpr3-release

commit 722974f4e93aedda99bf1a8e106f19a7acf14d58
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Jun 13 09:59:50 2020 -0400

    remove trailing whitespace

commit 195bc8c92a0ab2c9c5f39e40cd0cfe4738e9f855
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Mon Jun 8 19:21:17 2020 -0700

    added tests for malloc_object_size
    
    LDFLAGS is on single line

commit 577524798e1df4fba4be1d053198d784ed057afd
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Mon Jun 8 19:17:53 2020 -0700

    calculates offset from start for small allocations

commit 467ba8440fd0b382f6ef7b0034d6db2767b91909
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun May 24 09:36:43 2020 -0400

    add comment explaining slab cache size

commit 067b3c864f8caf24d5ec51f0014e58f285b2eba0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun May 24 09:31:02 2020 -0400

    set slab cache sizes based on the largest slab

commit 82440e78d9cbda71f8e0ca49b14381e56618eb55
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon May 18 19:10:14 2020 -0400

    silence annoying tidy checks

commit fc0bd7821592ce2b9fbe83893dec3861353254e4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 13 03:48:44 2020 -0400

    default number of arenas is currently 4

commit 08a5f5ee0b59cd60b943615a5f0ec7de72d46931
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 13 03:19:17 2020 -0400

    reduces empty slab cache size now too

commit e82367e1bf1a07223d314cce863821ad7a2daa75
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 13 03:06:49 2020 -0400

    include leaner sample configurations

commit 4a6bbe445c2a9b06cc564cc09dcafc9239564fd2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed May 13 01:05:37 2020 -0400

    limit cached slabs based on max size class

commit cf55ac0f6d324ed2b30dbc1418ca7b68f1645557
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Apr 30 16:36:47 2020 -0400

    disable annoying Clang warning from avoiding ifdef

commit b672316bc76ce942187fc03ef5ef2f7a288b583f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Apr 30 16:06:32 2020 -0400

    use const for memory_corruption_check_small
    
    This currently causes a warning (treated as an error) on Android where
    malloc_usable_size uses a const pointer.

commit 029a2edf28a390524533f351bd5c61d123934342
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Apr 30 11:47:24 2020 -0400

    remove trailing whitespace

commit 35bd7cd76dd59d6f1d27f94ce72097b972811822
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Wed Apr 15 21:09:50 2020 -0700

    added memory corruption checking to malloc_usable_size for slab allocations

commit 0a3a726c93878bc0c0bf9fac80fcd6719fda6153
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Wed Apr 15 21:02:16 2020 -0700

    added tests for malloc_usable_size

commit 19365c25d62329e397699c21bf1acaf170e22235
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Apr 24 02:51:10 2020 -0400

    remove workaround for Linux kernel MPK fork bug

commit 0188e9b16427d57e09d22b497f4febe92c134c1b
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Apr 16 08:33:08 2020 -0400

    bumped changelog version

commit 0f7e7382f91c91da45f2cc69009c0b41d57d2683
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Apr 15 14:05:32 2020 -0400

    readme

commit c75dcb9d9cfd8732dc593cb16cf3a6df79e0526c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Apr 11 15:26:24 2020 -0400

    compare with negative integers to check signals

commit d757835d9077d8bf1b7194ec22bb5e5e1d2661d5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Apr 11 15:17:37 2020 -0400

    increase size for eight_byte_overflow_large test
    
    This was not working as expected due to CONFIG_EXTENDED_SIZE_CLASSES
    resulting in 128k being a slab allocation size class. The addition of
    padding for the canary pushes it into the next size class, resulting in
    this writing over size class rounding padding rather than this actually
    being an overflow as intended.

commit 2c421590b5964f6c3d88c31be6b63b14bbe8cd01
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Mon Mar 30 17:12:02 2020 -0700

    added testing headers to table of contents

commit 9f661f945c50f209d8c7b4751feda0476f2196b2
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Mon Mar 30 16:49:12 2020 -0700

    added testing instructions

commit b160f723e011e4b93a7a3bde50097fcef8b12014
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Mon Mar 30 16:38:27 2020 -0700

    ignores __pycache__

commit ec6854c71b0f0241cb96782fe6e800885dd98eba
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Mon Mar 30 16:36:11 2020 -0700

    added test rule

commit 6b987e644b19889daf22d849c2498b8c25876991
Author: rwarr627 <r.n.warren@protonmail.com>
Date:   Mon Mar 30 16:30:43 2020 -0700

    verifies the results of the simple-memory-corruption tests

commit 2a87f52fc1a229c079cad54baf1f7ec70b6612e9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 7 21:28:02 2020 -0400

    use organization funding metadata

commit b9f9e3485e23671259928eb93c1703f406012c1a
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Apr 2 07:47:07 2020 -0400

    bumped changelog version

commit 0711d1e35463545c5e2ac116b96724103b3f81b5
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Apr 2 07:22:33 2020 -0400

    readme

commit cc2debfd0cb3b592244cb4fdcd75572f16d645e1
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Apr 1 10:40:53 2020 -0400

    bumped changelog version

commit 7259c014b41b8cd17ba87cdfda55930f0c323098
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Apr 1 09:15:14 2020 -0400

    copyright

commit 43bd75537a8cfdc1b60b6efcb718c4f38963be00
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Wed Apr 1 08:49:56 2020 -0400

    update copyright year

commit 466d351e9361705e7c8a44d9395f5eca3873369b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Mar 29 07:41:18 2020 -0400

    drop legacy glibc version check for pkey support

commit 043622709278cab8ad486eb7177ec36615b3f3cf
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Mar 29 07:39:23 2020 -0400

    no longer need glibc pthread_atfork workaround

commit 3af44d2e6a07b0be06fc2f7674d81055d1d1606d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Mar 29 07:31:45 2020 -0400

    can now depend on libc having a getrandom wrapper

commit a5abe5add6788f529e435af615fd092610cd7f52
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Mar 29 07:30:46 2020 -0400

    increase minimum dependency versions

commit 26134f9aaa690e109a60fb27f2e10c8c5de7fe8b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Feb 7 18:13:11 2020 -0500

    update copyright notice

commit 449962e04403702f14a3c4829aa36d3f1f0a79a7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Feb 3 08:38:53 2020 -0500

    disable obsolete glibc extensions elsewhere

commit bee398f860860dd669f05f682d4ba0377cba3467
Author: Valentin Churavy <v.churavy@gmail.com>
Date:   Sat Dec 28 14:18:52 2019 -0500

    replace __BEGIN_DECLS with extern "C"

commit a361a56f4d726d182c34d9e17db1c4d54650e281
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Nov 25 08:44:22 2019 +0000

    bumped changelog version

commit 21b5b8aaa5f9168c44888096f41b9459306bd873
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Nov 25 08:37:45 2019 +0000

    fix, use same version number as upstream (2.0)
    
    no changes to the core of hardened-malloc
    
    Debian packaging only

commit e1cc3afc4c5188e2d72aa22786620967a34b1104
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Nov 25 08:32:27 2019 +0000

    remove dependency on genmkfile
    
    allow building with `dpkg-buildpackage -b`

commit ad435e9feae664d45ef80653ef94cc0ccb50c980
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Nov 25 08:29:00 2019 +0000

    reset the upstream default Makefile

commit 4d4adefb56dcde92768ccf8eb64a201f10baa392
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Nov 25 07:36:50 2019 +0000

    move make-helper-overrides.bsh -> debian/make-helper-overrides.bsh

commit 7a089da4f706d35a493c8a00d6b7f9c848bae43e
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Nov 25 07:35:37 2019 +0000

    use version numbers by upstream

commit f0f72b4132500625c73526967bea67cdd5b958eb
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Nov 25 02:34:10 2019 -0500

    fix version scheme

commit 7c5c768e2f376d2169da93e3760635a80f2e24a3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Nov 6 06:04:16 2019 -0500

    update libdivide copyright

commit 7945b3f109773261f89382c32c4ab2e11d833121
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Nov 6 05:41:58 2019 -0500

    update libdivide to 3.0

commit dfa49481e561f535c24295192ccd649538beb85f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Nov 6 05:28:12 2019 -0500

    random: fix whitespace issue

commit 2fbf7bb25ec9a0b5648f91ed214029ef2a87eb85
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Nov 6 05:12:50 2019 -0500

    fix another README typo

commit ac95820fae2cf9e060fd5e24e944b8fdb6f6dd08
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Nov 6 04:57:41 2019 -0500

    remove duplicate word from README

commit b48ac93b035e843ebe1fe4ec9d53954c721dcc28
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Nov 6 03:33:04 2019 -0500

    current supported branch is android10-release

commit eff5037d64d1f54c5f441744598da101f851f2db
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Nov 6 03:30:46 2019 -0500

    add missing word to README

commit 97ea85f55d4dfa1e1a731b2754f631fd06a99a6d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 11 09:06:13 2019 -0400

    README: add Compatibility to TOC

commit 6f4de3971e16b40f0d682df41343926e9ab3c81e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 9 23:27:25 2019 -0400

    document OpenSSH compatibility fix

commit cb73bccf3533b4eba759e9669173b6ef8035f6ac
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 26 18:42:25 2019 -0400

    add GitHub sponsors metadata

commit 74eb614f1627f2e0c3b8ac946f1c0617517282ce
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 26 14:50:58 2019 -0400

    inherit base CXXFLAGS from the environment too

commit a28da3c65aed0528036da9ebd33e0c05b2c5884a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Sep 7 18:30:04 2019 -0400

    use prefix for extended mallinfo functions

commit fb9f5d630b131a3e3b490c7babd9fd2f5834006d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Sep 7 17:59:08 2019 -0400

    use cc_library instead of cc_library_static

commit 8d648e2b257979023e825616d5df29d7f7e7c849
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Sep 7 17:38:43 2019 -0400

    make it available in recovery for Android 10

commit 01a64a9a899d2c32f03d55cb5a4016f7435f1794
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Tue Aug 27 04:56:09 2019 -0400

    bumped changelog version

commit 6175f323d73c51bb18bc5a6a7f5778c30e9f3196
Merge: 8e69bfe 6d78dec
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Tue Aug 27 04:53:20 2019 -0400

    Merge tag '2'
    
    2

commit 8e69bfe6adcf8af5cc8ef39fe3d92cdd0a6651e0
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Fri Aug 23 16:54:48 2019 +0000

    bumped changelog version

commit 6d78dec42a7233f9c8d9cb3e6cf32ef86771960e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 20 15:57:59 2019 -0400

    clarify malloc_info format is a bit different

commit 2e4ab73fb67c3f9bbed068900d3483badb71fbc7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 19 06:11:10 2019 -0400

    basic design -> core design

commit 0e4ea0090b0b7bccc52b53ee8f8358384ce1a1ac
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 19 06:10:40 2019 -0400

    expand design documentation further

commit 3510356893dfb495dc1609034bd6721d1af54233
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Aug 18 14:26:52 2019 +0000

    reappend genmkfile

commit cd1840ea6c6cd81c0d8221f156f95f649a5c5b7b
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Aug 18 14:21:34 2019 +0000

    setting CXX no longer required
    
    https://github.com/GrapheneOS/hardened_malloc/issues/94#issuecomment-522303543

commit d054defaf0d2ed061b782fedb0c459bfd1b96f8d
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Aug 18 14:20:43 2019 +0000

    revert to Makefile by upstream

commit 5b3d59ec7dcc49d40b99a474457d2099df1e430d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 08:41:12 2019 -0400

    Makefile: split long line for SHARED_FLAGS

commit 7c455c39560f753964c12863e1413ef603f846f4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 06:56:52 2019 -0400

    update libdivide to 2.0

commit efda9509942889d58a59ef1abeebab64d50631eb
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 06:52:09 2019 -0400

    fix width of cell in memory tagging section

commit 40be77003e89706c6cef8cc9e6025c1e47481aad
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 06:48:03 2019 -0400

    fix OS integration header level

commit 0af33616f030f344947f7e518a42253da41030b6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 06:47:00 2019 -0400

    cleaner wording in introduction

commit c66cf10894f033502b5a20b26d3df6b8a1a01e49
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 06:45:53 2019 -0400

    clarify malloc_object_size state further

commit 0129d8e470e74ea60488321c13d95e0e020ad077
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 06:44:35 2019 -0400

    move point about delayed free for slab allocations

commit 5eefcd39b41f1f39a69b2904072b0387e206fa10
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 06:24:21 2019 -0400

    the design / implementation is fairly complete now

commit 2288b3a754c4bf9be98d3aa9f7df8fb02bdc5295
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 06:20:08 2019 -0400

    add information on stats

commit f4afedb1374bbf54d74a9c5c21adea3701a03b01
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 05:48:29 2019 -0400

    add links to size class section from configuration

commit ac70e2c250862631e2dcd3708ed5e86ab2ff0252
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 05:47:13 2019 -0400

    use full sentences to describe compile options

commit d0b466beb81a19d118ef47b698154eb0ee71cc23
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 05:42:53 2019 -0400

    elaborate on the cost of GUARD_SLABS_INTERVAL

commit 7a8c57d0f5546827afeba86db59b104489baeacc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 05:37:30 2019 -0400

    stop marking MPK support 'extremely experimental'

commit c4fc025fde2f1dd6e2f4f20db36c09165458b719
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 05:35:48 2019 -0400

    clarify ZERO_ON_FREE / WRITE_AFTER_FREE_CHECK

commit 58b56f10eae3a16d34ac4123f56fa90c8100cce6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 04:53:51 2019 -0400

    avoid -shared-libgcc due to old Clang versions

commit 4b859c81c5eeb7ef7cb782e961401789c1f01278
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Aug 18 08:50:33 2019 +0000

    add Build-Depends: clang-tidy
    
    to support "make test" which calls "make tidy"

commit 125efe99db7906874e7ac5bf077c08e1f2fb98f5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:51:32 2019 -0400

    fix wording in note about malloc_object_size

commit 77b242ea3fc6aa42a85c47c05c698229a1067e9a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:43:49 2019 -0400

    enable misc tidy checks

commit d37657e1258e1dbc3d1e3cbcf4e96312f59cf5a3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:39:55 2019 -0400

    enable llvm-include-order tidy check

commit 3c67708c3aad2ecfd82509facec8363bfe03fa64
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:34:38 2019 -0400

    reorder clang-tidy checks parameters

commit 2ad74515b1f093407a84e52b6ec59021211c8212
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:31:05 2019 -0400

    enable -Werror for Android build system

commit abece7656bc9c6737417f01df186dba43f70e14c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:28:23 2019 -0400

    add enabled-by-default option to use -Werror

commit c70745ab156fa0212cb5e8ffbb3a3a1a1be40c90
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:19:51 2019 -0400

    Makefile: add check target depending on tidy

commit 7d4d2ef0fb5149d988c80a6daaf957596ddf160f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:16:04 2019 -0400

    treat clang-tidy warnings as errors for automation

commit 8133444f43da67875463d300ca5e83068dd875a2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 02:12:18 2019 -0400

    move clang-tidy configuration to .clang-tidy

commit 8f9f2521a01020ac55096f7d386d9d021081d2ce
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:59:48 2019 -0400

    disable sanitizer recovery in UBSan debug builds
    
    This makes it harder to miss that an error occurred and avoids spamming
    output. There should never be a single error, so it doesn't make sense
    to gather as many errors as possible when a single error is already a
    serious issue that would need to be fixed.

commit d8ebdea05f5d5627c30af200803cca4008417e0a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:56:20 2019 -0400

    handle CONFIG_SEAL_METADATA option like the others

commit defd55f302ee0211f88ce98211aefaba8776ebaa
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:43:57 2019 -0400

    provide link to Bionic integration commit

commit 04f69d9f0de39955769e6f0d31820ec9a160c826
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:41:56 2019 -0400

    update supported Android branches

commit 995d0580d1f923615623092276fe05ca4cee9308
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:39:22 2019 -0400

    remove extra spaces inserted by vim joinspaces

commit 8d2df1deb8ddf2965dba5859ff9c8cf8dc1ef42d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:27:02 2019 -0400

    use CC as CXX to make sure LTO is compatible

commit 1bc201c4c179a3ddb8d12735d78e15265b99f5e4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:15:24 2019 -0400

    use -Wcast-align if -Wcast-align=strict is missing

commit cc8c4459e1147857b5e917e1c2744e442935fd57
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:14:45 2019 -0400

    make safe_flag treat unknown warnings as missing

commit b6b910f0323216b86d32c3204a085f6ad22a4887
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 01:10:20 2019 -0400

    add table of contents to README

commit 24de5aab05e4ad678bc703b49871bb02f0fc9cb8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 18 00:36:38 2019 -0400

    still need to finish up initial malloc_object_size

commit c0ed18686e2657bf95536b01ffdfc957e51a58e4
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Aug 18 03:24:48 2019 +0000

    port to build with clang instead
    
    https://github.com/GrapheneOS/hardened_malloc/issues/94
    
    https://github.com/GrapheneOS/hardened_malloc/issues/89
    
    https://github.com/GrapheneOS/hardened_malloc/pull/90

commit 71e45773673be84edbf8b45f8330204e153cc364
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 13 21:28:34 2019 -0400

    fix some inconsistencies in the tagging examples

commit a4b3f55a43532bf377bfd67f55160fc02ac54415
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Aug 1 11:41:37 2019 +0000

    bumped changelog version

commit e039114f3119e665b575e347fb84590154775ddd
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Thu Aug 1 11:13:39 2019 +0000

    readme

commit 75e86914aa7945d59b1728e33316319b3b44d8f3
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Jul 29 17:52:55 2019 +0000

    respect existing CFLAGS, CPPFLAGS and LDFLAGS

commit 1d877ad4b3cffbda2f2e45e5087dd0a37ad476f8
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Jul 29 13:09:15 2019 +0000

    bumped changelog version

commit eb39b494d618a86a241449ada701357a7321143f
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Jul 29 13:01:05 2019 +0000

    add README_generic.md

commit a963ac8a3497f1f979f38877a3f2cbc5a6b53686
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 28 19:30:10 2019 +0000

    bumped changelog version

commit 6cda93e9592705318e085fba9d58b107f3e9caa9
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 28 19:26:15 2019 +0000

    copyright

commit fae85f41074f4b60873fa7a771a9fabc8b851898
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 28 19:25:40 2019 +0000

    correct copyright year

commit 1618da1e91cdfcb356cd24b43acdc892a96f41ec
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 28 19:25:23 2019 +0000

    minor

commit b3b5e5d21de582e9e126bb49ce0d36c55a3f0619
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 28 19:20:03 2019 +0000

    add SONAME - https://github.com/GrapheneOS/hardened_malloc/issues/86
    
    use correct Section: libs rather than misc
    
    compatiblity with dh_dwz / dwz - https://github.com/GrapheneOS/hardened_malloc/issues/85
    
    move to sub folder /usr/lib/libhardened_malloc.so so lintian will not complain
    about non-versioned shared objects and missing symlinks. That extra complexity
    is not needed here since this lib aims to be compatible with what it replaces.
    
    full path is now /usr/lib/libhardened_malloc.so/libhardened_malloc.so
    
    deprecate no longer needed make_all_hook_post as this was improved in genmkfile

commit ccfb42c5b479c7dee38ef6eec66cd96ee6955e51
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 28 18:48:52 2019 +0000

    actually only CFLAGS, CPPFLAGS and LDFLAGS
    
    https://github.com/GrapheneOS/hardened_malloc/pull/92
    
    https://github.com/GrapheneOS/hardened_malloc/pull/91#issuecomment-515784158

commit b6685b29a162fa10b4bdd193b2295bede5ead6a1
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 28 18:20:17 2019 +0000

    keep existing environment variables
    
    such as CFLAGS, CPPFLAGS, LDFLAGS
    
    https://github.com/GrapheneOS/hardened_malloc/pull/91
    
    https://github.com/GrapheneOS/hardened_malloc/issues/88
    
    https://github.com/GrapheneOS/hardened_malloc/issues/85

commit 131b1ebd78bc3e9f87376e3832846f9983779271
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Tue Jul 23 01:29:20 2019 +0000

    simplify genmkfile appendix

commit 3a27245fca16e0fb244b45d77c1961e907ca9083
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Tue Jul 23 01:23:57 2019 +0000

    lower verbosity

commit 3fc23f8bfde30994d5b72c68b3dd4ab4ce27ed7e
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Jul 22 23:43:23 2019 +0000

    lower debian/changelog versions during development

commit 4a286a9d0e6fcc91205ede7e794684c772180707
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Jul 22 23:03:31 2019 +0000

    set CONFIG_NATIVE=false to not optimize for build machine

commit dc599bf62d6fa9ad328e4fecf2cc6812497c1a50
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Jul 22 12:05:53 2019 -0400

    fortunately no need to use versioned shared object file names
    
    https://www.debian.org/doc/debian-policy/ch-sharedlibs.html

commit b8fa714be73ff4ec9059e9be3abaab248b74024e
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Jul 22 12:01:12 2019 -0400

    move genmkfile appendix to bottom instead of top to not break the default make target

commit 4c00e74d456691b8faf9a5f9950ef9844a42e160
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Mon Jul 22 01:15:34 2019 +0000

    bumped changelog version

commit f7d78bba9c706b339ac8c9b46288d1703cd86482
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 21 01:25:40 2019 +0000

    /usr/lib/libhardened_malloc.so.1 instead of /usr/lib/libhardened_malloc.so

commit e2bba96033bf52ac4f770ab21758e6811378a830
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 21 00:24:30 2019 +0000

    fix changelog

commit 8cd51ca1387d499f3e37657d0429206c578a5a7e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jul 19 11:23:44 2019 -0400

    override local default to -fstack-protector-strong
    
    This is a no-op on a toolchain compiled with the basic mitigations
    enabled by default, so this is generally a no-op anywhere this project
    is likely to be deployed. SSP has a very low performance cost so there's
    little reason to avoid it, even though it also has zero value for this
    code in practice. It would be great if one of the more modern approaches
    was widely adopted, but unfortunately SSP is as good as it gets for
    portable options. It doesn't provide any protection against external
    writes to the stack data which is all that's really needed here.
    
    ShadowCallStack is a great option for arm64, but it's substantially more
    difficult to protect return addresses well on x86_64 due to the design of
    the ISA and ABI.

commit e6ff9c7468734af72cf25109fc2dc834521c51c9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jul 19 11:15:49 2019 -0400

    use -fstack-clash-protection for completeness
    
    This is a no-op for the current code and will likely remain that way so
    there's no benefit but also no performance cost.

commit f3e201bac99a04ec920c68988807995077976ff3
Author: Patrick Schleizer <adrelanos@riseup.net>
Date:   Sun Jul 21 00:20:45 2019 +0000

    initial debian packaging

commit 90d12fb340c2c5245c063d85a3c0136b11b971ec
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jul 19 11:23:44 2019 -0400

    override local default to -fstack-protector-strong
    
    This is a no-op on a toolchain compiled with the basic mitigations
    enabled by default, so this is generally a no-op anywhere this project
    is likely to be deployed. SSP has a very low performance cost so there's
    little reason to avoid it, even though it also has zero value for this
    code in practice. It would be great if one of the more modern approaches
    was widely adopted, but unfortunately SSP is as good as it gets for
    portable options. It doesn't provide any protection against external
    writes to the stack data which is all that's really needed here.
    
    ShadowCallStack is a great option for arm64, but it's substantially more
    difficult to protect return addresses well on x86_64 due to the design of
    the ISA and ABI.

commit 77743e5a36cdda57bebd163e4b7fec72a22eb865
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jul 19 11:15:49 2019 -0400

    use -fstack-clash-protection for completeness
    
    This is a no-op for the current code and will likely remain that way so
    there's no benefit but also no performance cost.

commit 3ed6e546c85ee9ac131122f31725830edfa7c01f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jul 18 07:21:27 2019 -0400

    OS integration guide

commit d80919fa1e8042a070a3f9b2560ff2ecac8a75da
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jul 12 03:43:19 2019 -0400

    substantially raise the arbitrary arena limit

commit 410e9efb93a8e30e080abf1a1c3fdd2247f8a64b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jul 11 17:07:36 2019 -0400

    extend configuration sanity checks

commit 7bcfa500beb3f2c6b0197e569287ce4386039f4c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jul 11 15:50:32 2019 -0400

    remove note about lack of sanity checks for config

commit 72a08f88fb05966fd90b24e924f76735f0890069
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jul 10 18:08:14 2019 -0400

    supports Debian oldstable due to Buster release

commit a32e26b8e9987177ef7573594b2aab2104ca9d3f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jul 5 21:59:44 2019 -0400

    avoid trying to use mremap outside of Linux

commit 934ab4cb5917b02ce6709f74b7df3f38cf89ccb7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jul 5 17:57:41 2019 -0400

    explain extended size classes impact on quarantine

commit 060f74b9932149cb648a4d8fa507145596646943
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Jul 5 17:55:25 2019 -0400

    extended size classes now go up to 128k not 64k

commit 4d4277319a3d2a724ac00af23f35ec395a54e32d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jun 23 19:20:16 2019 -0400

    clarifications to randomization documentation

commit a579257a26204a4b224324b85fe57c6fde70e7f3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jun 23 00:37:45 2019 -0400

    update libdivide to 1.1

commit bb65d088dc5e35c146b47b4fc3bfd4cc7d870b86
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jun 19 01:00:22 2019 -0400

    drop default class region size to 32GiB

commit 706c1970b502e23e7f5a63638bb57d9f68a5c2ae
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jun 18 22:54:49 2019 -0400

    add GitHub funding metadata

commit dba11c00915273dca718bf2004b3afc0316aed20
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jun 18 22:50:10 2019 -0400

    fix warning with glibc from cfree

commit 539d4f0d37eaea097e69a1ebe405d4bb991253f2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jun 18 15:51:13 2019 -0400

    add extended size classes to offset test

commit bc75c4db7bfa9ef095ec49d87b2f98f9f6d16198
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Jun 17 00:23:03 2019 -0400

    realloc: use copy_size to check for canaries
    
    This avoids unnecessarily copying the canary when doing a realloc from a
    small size to a large size. It also avoids trying to copy a non-existent
    canary out of a zero-size allocation, which are memory protected.

commit 37474e117c08a0c38dea53f603339b5914e9cd01
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jun 12 13:28:03 2019 -0400

    limit precision for fragmentation in table

commit 12525f28618ef577ea931a1dc151cd19a462aa73
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jun 6 08:10:57 2019 -0400

    work around old glibc releases without threads.h

commit 5449f4a94edd86024ec3478e586da692c46f136a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jun 6 07:32:52 2019 -0400

    use safe_flag for -fno-plt
    
    This isn't supported by the ancient Clang release in Debian Stable.

commit 64a1f590201a4cbe5dba8a119fc4570b7db0bc5b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Jun 1 04:06:43 2019 -0400

    note about getrandom with syscall whitelists

commit b40ba9754b92508737d70364e7b39a7c7828edec
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 30 16:54:58 2019 -0400

    add malloc_info test

commit f6f4402ff334204a666c84331662d9506de35793
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 30 16:52:38 2019 -0400

    expand test gitignore

commit 2ae0ed4674bae395405233c31c748f67173610ac
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 30 16:47:06 2019 -0400

    add large array growth test

commit ae4142c2d108b8362a23f80b40bd6997066054a8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 23 02:01:44 2019 -0400

    note that arenas are isolated from each other

commit 18f36c3e8d3a24ad0ff349fef79cc24d842940e2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 23 01:59:31 2019 -0400

    expand description of randomized delay free

commit 7f0bbddfcaf7aa6560e52db166059f684ff03a67
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 23 01:58:37 2019 -0400

    merge points about out-of-line / protected state

commit 409a6393128a48764e2fec0d1056ddc0a608d0c5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Apr 19 16:54:43 2019 -0400

    provide working malloc_info outside Android too

commit 494436c904b86193634de24e73d3b456a14e4f2d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Apr 19 16:23:14 2019 -0400

    implement options handling for malloc_info

commit 13ee04c8c32ac810d3430c8e26baa5b591be3f62
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Apr 15 07:11:39 2019 -0400

    fill CSPRNG caches lazily to speed up early init

commit a13db3fc686f093a781e137bd53f3b810fde4fce
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Apr 15 06:29:57 2019 -0400

    initialize size class CSPRNGs from init CSPRNG
    
    This avoids making a huge number of getrandom system calls during
    initialization. The init CSPRNG is unmapped before initialization
    finishes and these are still reseeded from the OS. The purpose of the
    independent CSPRNGs is simply to avoid the massive performance hit of
    synchronization and there's no harm in doing it this way.
    
    Keeping around the init CSPRNG and reseeding from it would defeat the
    purpose of reseeding, and it isn't a measurable performance issue since
    it can just be tuned to reseed less often.

commit c7e2cb82f4dea13492715341261e20c7fd06def2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Apr 15 04:52:18 2019 -0400

    add generic get_random_bytes function

commit f115be839276e0fc11ae53b392a51a504fca8096
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Apr 15 00:04:00 2019 -0400

    shrink initial region table size to fit in 1 page

commit e7eeb3f35cc8a3aa4db326110e157bf9b789f5da
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 14 19:57:22 2019 -0400

    avoid reading thread_local more than once

commit 7e465c621e92bbeabcc7b2cc8f894d1c7638160f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 14 19:46:22 2019 -0400

    use allocate_large directly in large remap path

commit 1c899657c10b2564bc8e324cb1be54f8e907474c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 14 19:12:38 2019 -0400

    add is_init check to mallinfo functions

commit 8774065b13d06b685547eced9ef76bfe9a29242d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 14 19:01:25 2019 -0400

    fix non-init size for malloc_object_size extension

commit 84a25ec83e75ac18c2ede0e89c2748c16604f364
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Apr 11 00:49:45 2019 -0400

    fix build with CONFIG_STATS enabled

commit 34b6754f7035f4bbc75a04a4bf8d294ef2b54998
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Apr 10 17:12:17 2019 -0400

    enable CONFIG_STATS by default for Android
    
    The tiny performance cost might as well be accepted now because this
    will be needed for Android Q. It's also quite possible that some apps
    make use of the features based on this including malloc_info.

commit d4b8fee1c4fe910efd0ccf7e897ce88b5178ac79
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Apr 10 16:54:11 2019 -0400

    allow using the largest slab allocation size

commit 086eb1fee401d2bd4f9d65df92ace8b41cba4329
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Apr 10 16:32:24 2019 -0400

    at a final spacing class of 1 slot size classes

commit 7a89a7b8c5294060097372964e4dcd23e06c0207
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Apr 10 16:26:39 2019 -0400

    support for slabs with 1 slot for largest sizes

commit b31e8dacb1e5ef28425f2bfa87c35eb82db79719
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Apr 10 08:42:32 2019 -0400

    document extended size classes

commit 6c31f6710a8f9f710e454507d84d8f8dcce25bbc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 16 13:26:59 2018 -0400

    support extended range of small size classes

commit 1b34fd4a69b706638d4582aa635f11e2b860aa32
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Apr 10 08:12:59 2019 -0400

    enable 4 arenas by default

commit d5f18c47b336d02c3bb0f8770078f3ee5700458e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Apr 10 08:06:56 2019 -0400

    micro-optimize initialization with arenas

commit 62c73d8b41ee01afb7a68f08247e91e9c33822bc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Apr 10 07:40:29 2019 -0400

    harden thread_arena check

commit d5c00b4d0d5007d645861f40861e7c1999aeaf18
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 9 19:15:43 2019 -0400

    disable current in-place growth code path for now

commit d5c1bca9153d8f4a548eb3552ae20d9c8322e373
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 9 16:36:01 2019 -0400

    use round-robin assignment to arenas
    
    The initial implementation was a temporary hack rather than a serious
    implementation of random arena selection. It may still make sense to
    offer it but it should be implemented via the CSPRNG instead of this
    silly hack. It would also make sense to offer dynamic load balancing,
    particularly with sched_getcpu().
    
    This results in a much more predictable spread across arenas. This is
    one place where randomization probably isn't a great idea because it
    makes the benefits of arenas unpredictable in programs not creating a
    massive number of threads. The security benefits of randomization for
    this are also quite small. It's not certain that randomization is even a
    net win for security since it's not random enough and can result in a
    more interesting mix of threads in the same arena for an attacker if
    they're able to attempt multiple attacks.

commit 9a0de626fcb0bb32a7b08092b5b422efc738e078
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 9 03:57:44 2019 -0400

    move stats accounting to utility functions

commit 02bfcc3b75ef17a2dbae08ca582988aa7d19eb9b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 9 01:29:25 2019 -0400

    chacha: add constant for number of rounds

commit cef7368b3cbb2ee2b438b0246c9655222c5798c4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 9 00:57:17 2019 -0400

    disable unusable readability-magic-numbers lint
    
    This wouldn't be worth using even if it had a whole bunch of heuristics
    like ignoring expressions in static_assert, ignoring repeated patterns
    like assigning different things to sequential array indexes, etc.

commit 295bfbde945330ccdfe9729bf5368b192a51261a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 9 00:43:00 2019 -0400

    disable bugprone-too-small-loop-variable lint
    
    This has too many false positives since it doesn't permit comparisons
    against constants where the compiler can verify it doesn't overflow.

commit 8b2b9d940a9bb8dfabc389a74811ada4822dd632
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 9 00:15:41 2019 -0400

    chacha: use C99 variable declaration style
    
    This further aligns the code style with the rest of the project and
    fixes the clang-tidy readability-isolate-declaration lint triggered by
    declaring all of these variables together.

commit 9453332e57a0f9583a1e4dce254e797b06362982
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Apr 9 00:06:17 2019 -0400

    remove redundant else block

commit 922c7419152aafdc362bc350b8c81becf382e491
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 18:13:26 2019 -0400

    it already supports Bionic, musl and glibc

commit a4cff7a960c1d55a86d6a7302d8ada9219fadb9a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 18:02:56 2019 -0400

    factor out slab memory_set_name into label_slab

commit ef90f404a640320fc34065425c33564377ce95e3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 09:06:03 2019 -0400

    add sanity check for stats option

commit e0891c8cfc8d5afbb9e721650db18c615f4009b5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 08:04:06 2019 -0400

    implement the option of large size classes
    
    This extends the size class scheme used for slab allocations to large
    allocations. This drastically improves performance for many real world
    programs using incremental realloc growth instead of using proper growth
    factors. There are 4 size classes for every doubling in size, resulting
    in a worst case of ~20% extra virtual memory being reserved and a huge
    increase in performance for pathological cases. For example, growing
    from 4MiB to 8MiB by calling realloc in increments of 32 bytes will only
    need to do work beyond looking up the size 4 times instead of 1024 times
    with 4096 byte granularity.

commit 7a7126e7805a0c6c9c3e6606ef4c1c37a7844e07
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 06:05:11 2019 -0400

    add infrastructure for a larger guard size option

commit c68de6141d7f91ba7968fa25f6092fc9685980b3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 05:48:10 2019 -0400

    factor out duplicated code in malloc/realloc

commit ce36d0c82601eedce03eca220ea65a1b3827ab9c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 05:30:07 2019 -0400

    split out allocate_large function

commit 3d18fb80742fd80a75481b580d102deb18c74af9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 03:35:26 2019 -0400

    implement Android M_PURGE mallopt via malloc_trim

commit 4f08e40fe5bca4e206fbb5eb01c379e74fe4e84c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 00:50:26 2019 -0400

    move thread sealing implementation

commit 55891357ff5d65d12bfd8b482e44dabe191fb915
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 00:36:53 2019 -0400

    clean up the exported API section of the code

commit 0651c819e3799184854b78762a339f59fba900ce
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 00:34:13 2019 -0400

    clarify hardened_malloc extensions section

commit 491ce6b0b1f4d02dbb410341947300970c47eaef
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 00:30:47 2019 -0400

    no need to provide valloc and pvalloc on Android

commit 1eed432b9a736d8820360431361679cacf21271a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 00:24:23 2019 -0400

    limit more glibc cruft to that environment

commit ec8fb347ed4344483bd6105c47e07ea847e7e586
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Apr 7 00:10:22 2019 -0400

    document CONFIG_STATS

commit beaa39a5a3ae5a62e9adb1faf91b74e343388a62
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Apr 6 23:45:31 2019 -0400

    move to only supporting current generation AOSP

commit 27a4c883ced2dc1eb62f974e559a0f127fa58af6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Apr 6 23:06:47 2019 -0400

    extend stats with nmalloc and ndalloc

commit e94fe50a0d02a4202ef5bb674f3690a4bdcd8de2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Apr 6 22:43:56 2019 -0400

    include zero byte size class in stats
    
    The allocations don't consume any actual memory, but it does still use
    up the virtual memory assigned to the size class and requires metadata.

commit 712748aaa88b2fa41f2ac06a74be201c6ea173f0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Apr 6 22:21:11 2019 -0400

    add implementation of Android mallinfo extensions
    
    These are used internally by Bionic to implement malloc_info.

commit 0f107cd2a32518734aee7dce4964a1ac7b775933
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Apr 6 22:01:12 2019 -0400

    only provide malloc_info stub for glibc
    
    This has a proper implementation in Bionic outside of the malloc
    implementation via the extended mallinfo API.

commit 350d0e5fd2e2a869e7dcf03b394f10c5670cac03
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Apr 6 20:49:52 2019 -0400

    add real mallinfo implementation for Android
    
    Android Q uses the mallinfo implementation in the ART GC:
    
    https://android.googlesource.com/platform/art/+/c220f981809d655fb061c92a581fd6fc4df4da5c
    https://android.googlesource.com/platform/art/+/15752673020e89df2a9353f332bd1409de4cd4b7

commit 7acebaa837c8990057cac6150d53b9912ab8f5fe
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Mar 26 01:45:15 2019 -0400

    overhaul glibc compatibility workarounds

commit df9650fe64c3aec1fd523ff8a81247de0d8d69b4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Mar 26 01:28:27 2019 -0400

    conditionally include threads.h

commit 98deb9de520cc8ed5439233a7c000a714c2f002e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 25 20:34:10 2019 -0400

    relabel malloc read-only after init data

commit fc8f2c3b608c9ee9b57a05e4a43923f72f67863f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 25 16:38:16 2019 -0400

    move pthread_atfork wrapper to util header

commit b5187a0aff55fa937048adb58da0f15c03ead837
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 25 16:37:34 2019 -0400

    only use __register_atfork hack for old glibc

commit 494cc5ec507d5bbcce479f33c2f35f887f9b304f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 25 16:14:54 2019 -0400

    update README now that arenas are implemented

commit c5e911419dee99db51adce79647ea2ca38d750d7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 25 14:49:50 2019 -0400

    add initial implementation of arenas

commit 55769496dc345b28d6b6715d31c1435b204f5df9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Mar 25 14:54:22 2019 -0400

    move hash_page to pages.h

commit 13de480bdeec2718a256612e38b2c8a050cc0155
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Mar 24 20:24:40 2019 -0400

    rename quarantine bitmap field for clarity

commit 3d142eb4c2122775026899fd68b1b18ba5e02235
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Mar 23 23:01:12 2019 -0400

    relabel large allocation guards when shrinking

commit 64dfd23f7bec9cb6591a39515cd9f85fa1a0cffa
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Mar 23 22:59:59 2019 -0400

    relabel purged slabs

commit 178ec6e3f9ddfe68a854b43a27413857804877d9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Mar 23 22:57:19 2019 -0400

    relabel quarantined large allocation regions

commit 6e67106882039f677a22ab18e55952c7880e67bd
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Mar 23 22:54:21 2019 -0400

    label malloc slab region gaps

commit 1d6207529170c9f7c41e13a161370fb9e3c03ce3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Mar 23 22:29:04 2019 -0400

    label allocate_aligned_pages mappings

commit c8b948e202267a86cca642d6736ad9be31f5c0f9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Mar 23 19:46:54 2019 -0400

    enable C++17 support when available

commit a0ee5f445b1759ec5a17596ebeaea3d73ea5a516
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Mar 23 13:41:12 2019 -0400

    remove redundant extern "C" block

commit 45337ebe078cf7f8f7dbead31a5ff2445550590a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Mar 22 23:17:26 2019 -0400

    label allocate_pages mappings

commit 65311a5df22ca607ae3ccd04ba8b9872b705ac8a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Mar 20 15:18:34 2019 -0400

    relabel region table mapping

commit e4120913d6d5397cba53f866808463ee5b93f874
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Mar 20 14:11:06 2019 -0400

    only enable LABEL_MEMORY in debug builds

commit 87acbcdf23048029e5398cb44a447c6ff294ae16
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Mar 20 13:18:27 2019 -0400

    replace C++17 aligned allocation functions

commit ddd616aa0b60802046169c23b0a40ac9a76cc8c9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Mar 20 11:56:32 2019 -0400

    add documentation on system calls

commit 4a000d96e29c05fa880ef99eeaec50a3f5a2ddcc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Mar 20 10:55:29 2019 -0400

    pkey state is now preserved on fork for Linux 5.0+
    
    This patch is going to be backported to stable kernels, so the check
    could be expanded to allow recent enough stable kernel branches.

commit c9df70d93462eeb3e802b5f6f0cdb3df1c3ee798
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Dec 11 12:37:37 2018 -0500

    add support for labelling memory regions

commit ae96835b94bce7aa889cae6231f900dc9e48a4b3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Feb 4 15:59:14 2019 -0500

    fix scalability header levels

commit e4061899aa9f80cd500950aec91ce48c26c9eed6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Feb 4 15:01:15 2019 -0500

    add documentation on scalability design choices

commit 41df5005e8ea053f3c8d10d5201bde69fe6a04ee
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Feb 4 13:59:19 2019 -0500

    add a top-level header to the README

commit 9cc0ac3efa64b0bf866699257a5f6af5cde686ed
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Feb 4 11:51:20 2019 -0500

    add basic documentation on memory tagging approach

commit 9398805fd85c0da6d8c1dae13be53308dfb7d953
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Jan 10 17:05:55 2019 -0500

    reference paper rather than fastrand for Python

commit 2d7882ec0ebdb35a12d5658896d4819b6bc52a86
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Jan 8 17:01:56 2019 -0500

    remove redundant unseal / seal metadata

commit fa17f70a731247eb2e27003988aae01e37be2823
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Jan 6 00:52:25 2019 -0500

    add more configuration sanity checks

commit 33b1a2740eed65dd6efc4ccd813eea8b98c4ad0e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 2 15:42:41 2019 -0500

    update default slab quarantine sizes in README

commit dea2788539e203f6e93bf15699548de441826216
Author: Arlo Breault <arlolra@gmail.com>
Date:   Wed Jan 2 15:27:51 2019 -0500

    fix typo in README.md

commit 8a474b647c469eddf2e3d568b1385dcf8215d6e7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 2 14:59:19 2019 -0500

    enable both forms of slab quarantines by default

commit 57f115b33c0a45637dd7eb8a6d2c64378fe0b25e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 2 14:22:28 2019 -0500

    scale slab quarantine based on size

commit ccc2a86501cda4095a8b96275942c37e82def2ed
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 2 13:40:02 2019 -0500

    rename quarantine size -> length for clarity

commit bc2cb5c828ef3b00f0a669310e1d1277b371687f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 2 13:23:49 2019 -0500

    fix builds with both random and queue quarantine

commit 5d3b299209ee85958d8c2b46a2fc23d6d0f73544
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Jan 2 13:03:25 2019 -0500

    support random quarantine sizes other than 0 or 16

commit 418cb1609cbcc62e837b8d3e63c1186faa288c3a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Dec 9 12:47:02 2018 -0500

    add RLIMIT_AS alternative to wishlist

commit 2d88b90282a6a100426c7bc3b33b9b10f2d15c7d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Dec 9 11:02:53 2018 -0500

    reorder Makefile CONFIG variables

commit 4dc3385bc0b0f45e793aace371f9b348c62e388c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Dec 9 10:58:34 2018 -0500

    fix calloc for nmemb == 0 and !ZERO_ON_FREE

commit 8a863ae847d4897b01019ac89716331ba7d93bde
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Dec 6 12:04:42 2018 -0500

    use conlyflags in Android.bp when appropriate

commit 830a7d338d0a9a0617673aae2ce902a173b3714b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 09:23:05 2018 -0500

    make class_region_size configurable

commit 8b0450555fbb28844a0b3b0f8b205f25df314e4c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 01:44:43 2018 -0500

    add initial Android build system support

commit a1e0d978645a4f6d53f3898651a1cdd2a7625ac0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 03:46:35 2018 -0500

    add __BEGIN_DECLS / __END_DECLS

commit ced3b0e070da1a8de9faf5bb38735d53cfe99079
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 03:27:09 2018 -0500

    support Android malloc_usable_size

commit 7917966ecac59f280b2657f399e277476fcdd64f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 02:45:24 2018 -0500

    avoid unnecessary GNU pointer arithmetic extension

commit 7f781af9292eb699b672e129a0ca767ad3859f61
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 02:22:10 2018 -0500

    explicitly include system malloc.h

commit 79cf5cbeb428b94016734adf51d4a0ac5a4d554b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 02:21:28 2018 -0500

    disambiguate malloc.h

commit f90fb3199d9343caebcabccc73fb2ac4e8635857
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 02:07:05 2018 -0500

    avoid redefining PAGE_SIZE/PAGE_MASK

commit 9fd0670aac6a989bcd29d264e181aebf3f9c6d27
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Dec 5 02:05:37 2018 -0500

    add lib prefix to the shared object name

commit 11fe467b7c7ed2f5542918bc27ff9142f0a9a351
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 19 08:04:37 2018 -0500

    clarify wording

commit c9dfe586b37210da30ebc48715cc265909db7ce1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 19 06:54:48 2018 -0500

    add initial documentation on API extensions

commit 4d85a61db26779cb7c73506ec9f47699835aa18b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 19 06:31:58 2018 -0500

    remove obsolete duplicate information

commit d88a8c98137a7adba9dd0df0545873b1986a6d33
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 19 05:44:56 2018 -0500

    mention that the same hash table code is reused

commit 433b37b4a95f052329f08f830b6c49e0c71a1ea9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 19 01:44:46 2018 -0500

    explain more of the size class reasoning

commit a052be762dfad21cac0b466182d85d3b6d59036f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 19 01:02:40 2018 -0500

    explain some differences from the previous project

commit a5ed64d01acdda1355daf09c85ef9406394596fc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 19 00:17:43 2018 -0500

    explain slot counts tied to slab size classes

commit 5b048a28c23b3b9d6eeb79bbd52145c3e58e4b0f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 19 00:11:15 2018 -0500

    improve explanation of jemalloc size classes

commit ac992827737b67f5b1949d66d0985acd6aa3c478
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Nov 17 10:53:04 2018 -0500

    remove duplicate word

commit 54a0313d9bad43665d4f2a295296101602e077f4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 16 18:41:27 2018 -0500

    split out dependencies section

commit d208d093a222127cd525a9e3b0fe45e64ddfb829
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 16 18:35:19 2018 -0500

    add more of an introduction describing the project

commit 2bb568b4731a860296c8add480d5908ea4e4bfaf
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 16 18:04:46 2018 -0500

    improve documentation about mapping count

commit 8a38c4fb2a92a8007ce4c012a1505514aeb174ba
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 16 15:36:34 2018 -0500

    add initial documentation for integer options

commit f3623e1f2bdc2be9ade21df967506d67e73911c1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 16 15:25:35 2018 -0500

    finish migration away from config.h

commit 06149aa156507b9a09a74b5f8bf7744522c4ceb2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 16 15:12:10 2018 -0500

    enable readability-else-after-return tidy check

commit 58c7079db9a2e9e23ab990dd466aa18a8711bc22
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 16 14:58:55 2018 -0500

    eliminate unnecessary code duplication in calloc

commit 315415acf23dba73e109585567d08052d20eb3be
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 16 03:26:07 2018 -0500

    clarify write-after-free detection feature

commit a617f7604d9b2f1272b97883fc46a4b96c8bf584
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 12 05:37:20 2018 -0500

    switch malloc_enable to enforce_init

commit 3cd3d34b3e3a15bcae0e956aeb981a16662c1fc3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Nov 6 04:23:53 2018 -0500

    extend gitignore for tests

commit 11c717a7b93f83092222bf779f3472bc224bce14
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 5 18:06:54 2018 -0500

    update progress on randomization

commit 2d892e58ad8947219b16042c28219ccf034c5375
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 5 18:05:56 2018 -0500

    per-slab canary values are good enough for now

commit 3a488c9a271eb14caf208ba123de4e5d47b72a59
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 5 16:19:50 2018 -0500

    add initial slab allocation quarantine

commit fea335282a35d9b34ac61af5cd37b1b833a3bb03
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Nov 5 02:19:04 2018 -0500

    use slab_region_start for init checks

commit a8112fc5c3a7b28bedd86d34c068e329b34300e1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Nov 4 19:45:04 2018 -0500

    use -O3 instead of -O2 primarily for more inlining

commit ca465f6b3ee8f1d184f4fc6af243f0b84deab3b9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Nov 4 18:52:01 2018 -0500

    clarify scope of sized dealloc mismatch detection

commit 505b9d2e7644771303cb779e693b066779c51c36
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Nov 4 14:32:03 2018 -0500

    add missing -Wl,--as-needed (removed by mistake)

commit 943a81fbebb6c8644ae3cee7d151c1f71426d6e6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Nov 4 14:23:12 2018 -0500

    use smaller integers for random cache state

commit 1fed72a9c3e041016d98990005d64d8509e82c69
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Nov 3 05:44:49 2018 -0400

    slab internal fragmentation is always the same

commit c12d6795de93a93287561fc627bf25cf55dfef38
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Nov 3 04:47:45 2018 -0400

    expand a bit on future config for slab cache size

commit d5b773b2bc5b1ed5b7a4be09e910d44fddeebed6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Nov 3 04:40:13 2018 -0400

    clarify documentation about the 0 byte size class

commit f949698c7a1af8ace5b4d8339de0e742c6f4e45f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Nov 3 03:11:59 2018 -0400

    note that MPK-based hardening is off by default

commit f2a7ccde75b218fb4a32bc8a90e0d9907731c78c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Nov 3 03:09:03 2018 -0400

    add basic overview of part of the approach to MTE

commit 1da51ddde190de37690efacb0186ac99e4c19ef1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Nov 2 21:35:09 2018 -0400

    migrate bool configuration options out of config.h

commit 4ac2688d76d417a7f325d3530c89d829e3675566
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Nov 1 01:00:59 2018 -0400

    add support for slab metadata count field

commit 834ce6788406e010aec06413793b06fa01cf0219
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 30 19:22:56 2018 -0400

    make canary generation consistent

commit c29a1836874344840a6a90e90735b6e1641f26b8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 30 18:09:07 2018 -0400

    reduce overhead of slot randomization

commit ceffb1a0ecaef7407f273d9301f9906ab9f87cd1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 30 16:37:23 2018 -0400

    simplify get_free_slot loops

commit a02f4ebb1956990d233a60fa64b4c5d49a5c44d1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 28 23:23:54 2018 -0400

    add missing deallocate_small thread_seal_metadata

commit 5bee717134fd80d6844a96bf6bbc40a033313adc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 28 22:31:46 2018 -0400

    use -march=native by default with a disable toggle

commit 00915521a3eda96f82f393cecc41b5fc39501140
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 28 21:07:35 2018 -0400

    check canary before zeroing as an optimization

commit 6f30211da865233df0ba01d5d92eeaabeaecda85
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 28 20:28:10 2018 -0400

    some clarifications for the README

commit b99ab8a47a5e725c413587141ff826589b0388f6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 24 03:09:04 2018 -0400

    no need to artificially limit sealing to x86_64

commit e985afe0e16f4e1f0d178476342de10bce5d2c0c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 23 19:38:00 2018 -0400

    document relatively high performance cost of MPK

commit 4cd61e281dbdab118e1a1a4ec06dbaa12f5a9933
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 23 19:07:41 2018 -0400

    add workaround for bug in Linux MPK implementation

commit 299bd6d414bc1d019c830f1642692252586a6711
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 23 16:28:54 2018 -0400

    add missing thread unseal / seal for atfork hooks

commit 9d1567ce16e486777c3f8f5aa5e016dc99082a7e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 23 15:55:45 2018 -0400

    make safe_flag check compatible with POSIX sh

commit 59def67979d980dd91d5cc5b1287ab3856e2044c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 23 07:40:14 2018 -0400

    add inlined check for -1 with pkey_set

commit 05ac717cf284deeb511fd5126f65996246831d90
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 23 07:23:07 2018 -0400

    work around -Wcast-align=strict error with old GCC

commit 0b963078d56d227fd75b9317f4be5a77c632cefe
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 19 21:29:40 2018 -0400

    guard metadata with Memory Protection Keys (MPK)

commit ac8c68de536ec071913bb2f78f7cba6b57c8866f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 21 15:50:26 2018 -0400

    enable pointer cast warnings

commit 9a43302868040f7ca90a809b53c6390d55c7f8d0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 20 02:27:06 2018 -0400

    add enforce_init call to other realloc code path

commit 6a408ad0174e0127e48e065e4855b532782faaba
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 19 21:46:36 2018 -0400

    add init calls to malloc_enable/malloc_disable

commit 173ed535396c323e259659498cca13a3ee015209
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 19 17:07:30 2018 -0400

    use consistent code style in chacha.c

commit 1d2c10f5bb433e2482ec7233d1ff7433e6006d0e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 19 16:17:38 2018 -0400

    tweak canary awareness in offset test

commit 64b655f0624037a9c74822b27e0ecc333a584f1b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 18 20:33:48 2018 -0400

    set scope of planned metadata protection

commit e37b36c9dd722ff569d6067feed845da75146f38
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 18 20:18:55 2018 -0400

    update configuration documentation again

commit f0a6f551eb765df941ff32f8f3bd3a6659747c53
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 18 19:35:21 2018 -0400

    tweak code style

commit cf053e74d1182f7006b0784994ba6b67b761c9ee
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 18 16:10:49 2018 -0400

    metadata region unification is completed

commit 1e03b004f562f2dc213cd5326d72d3c21cbb622d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 18 16:01:04 2018 -0400

    move slab_info to main metadata region

commit 3f1962dd2bb367a49d39c2e564172010865174b0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 18 15:25:14 2018 -0400

    use min macro for realloc copy size

commit fe30f6c2ea784dd8f57f3ce9f5e220752ff963f9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 18 15:19:54 2018 -0400

    delay allocating slab metadata from reservation

commit 74139112d0b5c6002a3bdefd1c73b77fd24b3737
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 18 14:57:05 2018 -0400

    explain the purpose of CONFIG_CXX_ALLOCATOR

commit 64e9f6797ad8c38c1c44c15a1e75135296a1e966
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 16 15:52:41 2018 -0400

    use offsetof for allocator_state memory protection

commit 67ada4d3095c061cd2450ab6884234a04907e02e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 15 19:08:20 2018 -0400

    document padding for allocator state

commit da8e9aa1d81e845338a25a25e6196e547e372736
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 15 15:43:46 2018 -0400

    document allocator state region

commit 1c9e0d88a567479fdad84be1587a9798c82b66d9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 15 15:09:41 2018 -0400

    use the initial region table slots again

commit da0df69d22d69810c787fd0a458da8a26a807995
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 15 15:07:59 2018 -0400

    move region hash tables into main state region

commit 1e5dec97e0cde0a8086beaed4fbb2086af2a5661
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 15 14:46:57 2018 -0400

    move slab allocator state into main state region

commit e8eca2d4305bb8a72caf6c10d6d91a5d078bfdbc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 15 04:04:51 2018 -0400

    explain the production-oriented design rationale

commit fde9fc2ece2a8e510cec335b420694066d51f08d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 22:41:17 2018 -0400

    protect region allocator state with random guards

commit 124d958da17907c378de9bee02cef8b17dfe9eac
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 22:19:10 2018 -0400

    document free slabs quarantine

commit 3504465584765b2059f8095751ece78c665146de
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 22:12:03 2018 -0400

    document progress on protected allocator state

commit da6fd5b5ef9245b541870f72355e695d80f53c3a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 22:06:16 2018 -0400

    move slab allocator state to a dedicated mapping

commit 11909668461f8cb03c7edc2e88a048d7ea281151
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 21:54:23 2018 -0400

    rename region_info to region_metadata

commit a083ff79e13a0f2f4630c863a4d5863a192b0285
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 21:12:37 2018 -0400

    move region allocator state to a dedicated mapping

commit d728afae8e2d162c63fced7293192e4e0f724810
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 18:58:54 2018 -0400

    add configuration option for testing with UBSan

commit 535466fdfd8f64bfb2a6488254b79da954867c92
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 18:57:59 2018 -0400

    avoid undefined shifts with multi-word bitmaps

commit 7798b2693e4e9b95da350fa5ce53d610dc5c8114
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 18:49:48 2018 -0400

    fix loop exit condition boundary for get_free_slot

commit 3c0a448c3e2f85773df3f8579bf1c7e49b31d8b4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 18:33:40 2018 -0400

    enable more tidy checks

commit 9ea2fd6667834995c4d39b49a8454938f49fcb6c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 18:30:20 2018 -0400

    write_after_free_check only reads data

commit d35674c67e40d86d85d19e5f56f92029bb52ae6c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 18:28:01 2018 -0400

    expected_size is not an output parameter

commit 8b033c5e44be8509e38f668b9e245ac4a6c67a56
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 18:20:18 2018 -0400

    make ALIGNMENT_CEILING into a function

commit 118549451b238ab149bc70790e2832d0560878dd
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 18:01:40 2018 -0400

    add tidy target to the Makefile for clang-tidy

commit b66ca56ba14c9053c09cd6891c739d31a509fa65
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 17:59:43 2018 -0400

    initialize ptr to nullptr in handle_out_of_memory
    
    It will break out of the loop in the first iteration if there's no
    handler or the handler throws an out-of-memory error.

commit 4fbfe4d3ecb5f4a7a9967af2587ede80ef0cbbe2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 17:43:03 2018 -0400

    fix canary space reservation for pvalloc

commit f11c448a0d21c863c2d8cb630ada6763f931f1d2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 14 15:09:55 2018 -0400

    slightly reorganize slab metadata

commit 3db3e167ede6a9bd035f9145b5cb817954e150dd
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 13 16:49:06 2018 -0400

    remove usage of ATOMIC_VAR_INIT
    
    This was never truly required in practice and has been officially
    obsoleted in C17.

commit 65a7014b48b3231753b64200bcf0fb6a0073da3d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 13 13:55:44 2018 -0400

    randomize free slabs reuse

commit 83df37436d3b10fc51d2ecc164f04527e4069b8b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 12 16:02:23 2018 -0400

    fix usage of pthread_atfork for glibc < 2.28

commit 0a64c7d6a186b7e87030e7c34378c51c1e2bf120
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 12 15:10:35 2018 -0400

    document the randomized array in the quarantine

commit 6669166fe98a9fe918c7c5c47d3956b6f295dd7e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 12 15:06:51 2018 -0400

    move memory_unmap outside of lock scope

commit b2007ad3d9d3acd9628c012f3da567f3e13121fe
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 12 15:03:59 2018 -0400

    implement randomization for the region quarantine

commit ac2b940f0f271533fec927e59d9fe237af4364b4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 11 18:12:20 2018 -0400

    fix compatibility with older GCC versions
    
    Avoid relying on compiler extensions supporting more flexible usage of
    constants closer to how it works in C++.

commit e47c78352401923504da822fe27a4fc50f86b4ae
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 11 01:44:41 2018 -0400

    add test for delete size mismatch

commit 7606bf4c1f3e7315cedecfa9d61c35fd442434d4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 11 01:35:25 2018 -0400

    clean up includes in new.cc

commit 54c78fe1c25a2146b675f1942dcb77bfd0562a96
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 10 19:05:35 2018 -0400

    distinguish between mmap / mremap errors

commit 2381d973b1c14ad8312275a88baab3317aefa959
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 10 18:55:31 2018 -0400

    expand on metadata address space security

commit 29fd86ab37493c1af429d0d66987f9e7638301e7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 10 18:48:45 2018 -0400

    document sized deallocation validation

commit c74fe560918843521ce0db2b5d6ecf4366f723a3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 10 18:19:56 2018 -0400

    minor include style fix

commit ddcdd9423ca2220e41729cd38836003377db6451
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Oct 9 14:08:36 2018 -0400

    make the memory mapping quarantine more efficient

commit 57d5ab769be05b8d85e9a36d98b9fb2c451c9de5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 8 17:41:06 2018 -0400

    add write-after-free tests with potential reuse

commit 5fa6e01929e7307c729f40dbc4e25b4acfaee8f2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 8 17:09:57 2018 -0400

    clearer name for MREMAP_MAYMOVE threshold

commit 1a10c17e8b8073a3343aaa1ea1db3670d84842d7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Oct 8 15:50:31 2018 -0400

    add quarantine for large allocations

commit cc9699f1b40d67bcf8042aa35fc59c187d9bb6df
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 7 13:34:52 2018 -0400

    use multi-word bitmap to support up to 256 slots

commit 5e2f03296e6bd5fc29e533de5b27a4506821e782
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 7 16:18:17 2018 -0400

    remove old debugging code

commit fa2796a941eeef1870092384a50e5201d3cb0d69
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Oct 7 11:28:50 2018 -0400

    Makefile: add missing dependencies

commit cf07ae600750d9a50ace16f8bdf486a2af2c1e5c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 6 15:37:50 2018 -0400

    update configuration in README

commit 348f9fa557ebcbf86fa8d0058e78bf2f12aa925a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 6 15:36:03 2018 -0400

    add configuration for frequency of guard slabs

commit 4ee12e64e0726e1245ce21f5449af5281e53bce2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 6 15:17:55 2018 -0400

    configuration for guard region sizes

commit d18b05eaf40606e7908dde97fd04aca9419dada1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 6 13:31:16 2018 -0400

    avoid redundant checks for large realloc

commit eb7ced7781dcd5c240cb6998a398d3ac1c3308be
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Oct 6 10:40:55 2018 -0400

    implement in-place growth of large allocations

commit 3a936295f8b647b23cf95cd7c490d777f33a4eb8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 5 02:45:40 2018 -0400

    Makefile: split out shared compiler flags

commit 4716ff5b92c9a2ce02fc422e36ca6274b0cf5701
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 5 02:22:17 2018 -0400

    explicitly export C++ allocator overrides
    
    This doesn't make any difference for GCC, but these aren't replaced
    outside of the library with Clang without explicitly exporting them.

commit e6e9ac1fc9ee9b31923eab4af6e08c6d74d41cfb
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Sep 19 13:57:35 2018 -0400

    support replacing C++ new/delete implementation
    
    This adds support for sanity checks based on sized deallocation and will
    reduce the overhead of calls through the C++ allocator.

commit 3dc49f8f73da52046777c505f85ccffd5dd7f3a6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Oct 5 01:05:40 2018 -0400

    slightly improve sized deallocation error messages

commit dcd969ae0471fec6f96ac9a772d5673d9dd1b6c1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 14:25:16 2018 -0400

    use a consistent style for fixed-size int types
    
    The stdint.h types don't cover 128-bit integers and the underscore makes
    them ill suited to usage in function suffixes. Instead, use the common
    naming style in the Linux kernel and elsewhere including the ChaCha8
    implementation included here.

commit 92a33182fbf4a3476d601b0f493bcd55e493da57
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 04:13:28 2018 -0400

    port chacha.h to the code style used elsewhere

commit 08a633b24473f56370d154929922de4f89e1dd24
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 04:12:21 2018 -0400

    fix another typo in the README

commit ef32a4b7ea79c517125629ed1d3ae78aec88afc3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 04:03:48 2018 -0400

    add -pipe to CFLAGS

commit e99191d5d4c270b1eb3ed88094e93ae3e818b42a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 03:44:19 2018 -0400

    document tuning vm.max_map_count

commit d12cf324dd01a731f17f71cf4a1187e0f2bdfc96
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 03:27:30 2018 -0400

    add documentation on testing

commit 2a31c7291b973771a7da7c8766966fed6aac9192
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 03:15:55 2018 -0400

    add basic documentation on configuration

commit 642eed81c0a664504e6a1a33bff569b4fc428f0c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 02:57:15 2018 -0400

    allow using larger guards on large allocations

commit 9b7691a2a745f8d89e36d6103947bdeee1b31a3c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 02:52:20 2018 -0400

    take canaries into account for the offset test

commit 71d52d981ea8e96961098e990ecd505ff3851b9e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Oct 4 02:40:51 2018 -0400

    fix output of size class offset test

commit 15e5e2d0ac4495f97ae3fc11cfc02d3433ce9d53
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 17:23:20 2018 -0400

    fix typo in README

commit 5811bd184c3a72ab9ab0cd0f955168627b77aed2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 17:17:20 2018 -0400

    avoid unnecessary preprocessor use for canary mask

commit 93fcc6a9780e45af260aedc0a2c96b7ca247260e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 17:15:38 2018 -0400

    add simple string overflow test

commit b24569b6ca8265d21e2266016fe9245b33b45343
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 17:09:57 2018 -0400

    zero leading byte of canaries

commit 1fbf0e27f594105816cc374fc587575cbc1066c8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 16:55:25 2018 -0400

    make error reporting more robust

commit 6dfe33b4f1b7649cfe80aa8ea50de4964caf6658
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 16:22:28 2018 -0400

    add prefix to reported errors

commit 6372fee41078159777ef055f9790df447c27d84a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 16:00:11 2018 -0400

    use consistent macro naming convention

commit 829ace403fa22dae1d4971f20ae1e2a354b05b1f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 14:37:05 2018 -0400

    document free_sized API

commit c3a580727a9a844da05ae4e2787a937253b09427
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Oct 3 13:18:51 2018 -0400

    add MIT license

commit cf449b3df4d1c611f168a6b47687091a14da2494
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 18 17:28:52 2018 -0400

    add sized deallocation support

commit 82314f4471ea27bd09cbfa83a2380f0f98f600c5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 11 14:51:36 2018 -0400

    make get_size_info straightforward for zero size

commit 7a404ddbf2d2648187b34295b75de084d9ae56f4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 11 14:44:15 2018 -0400

    optimize size calculation for 16 byte spaced sizes

commit 2d6ad18aa4ce46a82b84972e11f216b5ba2a85ac
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 11 14:18:13 2018 -0400

    make function naming a bit more consistent

commit 684291bf6abfea71c7f07d3ee8e5b5032e309419
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 11 14:13:18 2018 -0400

    avoid overhead of init check for slab deallocation

commit ef098fea06286ea18d83cf0ea5833ee8f14f00fa
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 11 14:12:27 2018 -0400

    simplify init function

commit 433af6d4bac8c3bff384abcb72399148346ad984
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 11 10:22:28 2018 -0400

    drop 128-bit keys from ChaCha implementation

commit b52d9ca831f9d8b94f0e300f0eee29328edca4ca
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 11 05:17:22 2018 -0400

    aggressive write-after-free check is implemented

commit 61684925e8bc737596d161857f3b1faac42090ee
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Sep 10 17:42:58 2018 -0400

    fix overly naive slab allocation alignment support

commit 9a1acce5eb2772fbaddd1fa75e4fa18490bd9f4b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 16:32:51 2018 -0400

    optimize calloc when zero on free is disabled

commit 8f921e30beb1d628825708f0ecf26c9241556109
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 06:32:07 2018 -0400

    add kernel feature wishlist

commit 7ae7abedea8639d3e069a4d4a1e2cd6522836c3f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 02:53:15 2018 -0400

    mark more unlikely code paths

commit 191f9667df67adab8b0b6ff0456f6a6095e32ce4
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 02:10:37 2018 -0400

    add missing include

commit 49af83a817907cd9f6d7f35b8ad9bfdf2feb602a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 01:08:51 2018 -0400

    wrap mutex type to enable future optimization

commit fc2473e7ee98b509129f760a0099387c6b173bfb
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 00:35:08 2018 -0400

    add configuration for canaries

commit 96c538d90fb637834fb5b530a8d1094bde4d2ccc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 00:33:51 2018 -0400

    add configuration for zero on free

commit ba3a8b0058462765184a4e239cbe7b16ef12c56c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 00:25:02 2018 -0400

    add slot randomization to configuration header

commit bed303a76f86fdb13024d955345cfd77c9d61f35
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 00:22:51 2018 -0400

    remove unnecessary else branch

commit d398384b90723ae17d06f5db29ce4e18ddbed292
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 00:17:22 2018 -0400

    add header for configuration

commit 99d68238d2f0375162a96deda8a16848fdb0e158
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Sep 7 00:00:32 2018 -0400

    implement slab allocation write-after-free check

commit 918f0d33022a6a8f6f5df04b362202fff16d183f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 23:48:47 2018 -0400

    improve write-after-free tests

commit 3751b85e47831a4089c6f5a17a68eb7422f34ea8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 19:52:09 2018 -0400

    document minimum musl version for external use

commit 684e63a87801ebc34432c331c9c8b7730ecd9f54
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 19:43:18 2018 -0400

    handle pthread_atfork calling into malloc
    
    This results in compatibility with the malloc replacement support added
    in musl 1.1.20.

commit 1be74ec40d9ccdff4b1e2eb5e97604557e308cbb
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 18:53:06 2018 -0400

    add initial guard slabs implementation

commit cc1e79fdbaeb6bf4b27dee52d479202a81a2fb76
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 18:41:00 2018 -0400

    abstract metadata allocation to allow guard slabs

commit d8e18e0011587b6c8ad95b4dd12c8ea9c5065497
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 16:30:22 2018 -0400

    aligned_alloc is now the same as BSD memalign
    
    The resolution to DR 460 (which is explicitly included in C17) removed
    the requirement for the size to be a multiple of the alignment.

commit 0d3c2e1988ebc0821841127a585572e20d8e4ce6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 16:02:15 2018 -0400

    no need for a dedicated init rng

commit 8624201f061d469251f7b6ff22c7feb8c5a2e664
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 15:07:01 2018 -0400

    refresh canary value when allocating free slabs

commit a875951e825a9b8c4bbcf4e058fa4cc8d92e2935
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 14:35:08 2018 -0400

    fix build with musl

commit e891b40588c8d00aa2ef649c5d9b500123b33931
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Sep 6 14:17:06 2018 -0400

    implement Android malloc_disable/malloc_enable API

commit 3a532b17dc38408a431e2b70f038a91351ec421b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Sep 5 05:17:40 2018 -0400

    implement in-place shrinking for large allocations

commit 645209dcbf664123c726db6f6a71a225bcebeb1b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Sep 5 03:41:56 2018 -0400

    remove unnecessary debugging code

commit bf55fad6d04c3ffb031886eba155403ed7dcaa9b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Sep 5 00:19:27 2018 -0400

    document that slab canaries are implemented

commit 9ddd53d56c0dc30532d2e915da7845a7da18092e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 08:36:48 2018 -0400

    implement initial slab allocation canaries

commit 5017500a4784942f50e9f6e6da13832bc19da11f
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Sep 4 09:06:23 2018 -0400

    add simple overflow tests

commit 1a7b8079d09c2965724882819dabf284d62b816b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 19:58:57 2018 -0400

    reuse is_init when possible

commit 7733047c7bbab01d755f649f7b29bd2356c74887
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 19:41:26 2018 -0400

    trigger early initialization in a conservative way

commit 2ec65306dd8252c7c0d1ebdd9db4dfbe19d961f7
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 06:05:37 2018 -0400

    expand documentation on supported environments

commit 8bb686e697d80171e839ab965e120d4665786a26
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 05:24:25 2018 -0400

    add missing prefix defines

commit 9c74a67068002f6c90dd711542a3b4c2a763af25
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 05:13:07 2018 -0400

    malloc_get_state/malloc_set_state are obsolete too

commit 7e088dc870807cf1d050273e843fa7bac6d53137
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 05:08:45 2018 -0400

    add stubs for Android extensions

commit 2dd2471b4a8db4cff7a7e28988259b18f94e329d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 02:27:49 2018 -0400

    enable more linker sanity checks

commit 39e81bd486f30c60eee3f09bbf12c50beaa7d2e3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 02:12:45 2018 -0400

    using -lpthread for linking isn't necessary

commit 89c624b7550f8fed7b300b9ce22f7866b74d5ece
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 02:08:44 2018 -0400

    mark page management error code paths as unlikely

commit e4648192c03912f17886ce5e97c7055875784b2b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Sep 2 02:03:27 2018 -0400

    split out code for managing page spans

commit e93d0392140f1aac40a9888f83f8f3f5d7c09fe6
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Sep 1 10:20:23 2018 -0400

    only use reserved memory for regions hash table

commit c3a4829d77a68026e46059f10f17bd05493c1ef8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Sep 1 02:38:00 2018 -0400

    remove unnecessary special case from realloc

commit f441dfe2e33650f8741a156cfb5bc0275a4e4b5e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 31 23:10:26 2018 -0400

    align size class metadata to cacheline size

commit fad10ce943dec81dde6c8c114183fc4d02be2038
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 31 22:42:34 2018 -0400

    use FIFO queue for free slabs

commit dba330fde73be42ec36cabd2486a40182257d980
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 11:07:20 2018 -0400

    expand documentation in the README

commit 3f808958223084b246d656019bff9ca11c8a9612
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 09:29:15 2018 -0400

    ignore pad argument to malloc_trim per glibc
    
    The pad argument is only used by the main arena for sbrk in glibc, with
    every other page size gap purged with MADV_DONTNEED. It makes more sense
    to simply treat it as an ignored legacy parameter rather than trying to
    come up with a sensible way to use it for keeping cached free slabs.

commit af393afc090259d44cdc1ae69effdd02efc1628d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 09:08:33 2018 -0400

    make preload script for testing a bit more robust

commit 1ea997b887ab23b9374a34f30acd6b88bd617e32
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 08:48:09 2018 -0400

    add missing headers to malloc.h

commit 2b0f7aa985064efd7d9f8faababdf5c0b7e04d56
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 07:13:18 2018 -0400

    use a consistent name for size class integer index

commit 0f5f2bf6c953a4b4243d2cb3952ab0494a57e025
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 06:44:58 2018 -0400

    add basic initial heuristic for freeing slabs

commit 456dfe4154e2b51836f58c394ee29a2e01844138
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 05:18:38 2018 -0400

    add support for purging and protecting empty slabs

commit bb176e09bc874cad64ee558a93ffde39835a13b0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 05:42:45 2018 -0400

    remove useless code in the empty_slabs path

commit 29df2429c2c23d3bd90d135c8a6b8760f18a02dc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 05:27:16 2018 -0400

    empty_slabs will remain a singly-linked list

commit f94068ea63c6d6bbab646ea4aca1894a92e76fc2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 04:55:39 2018 -0400

    rename free_slabs to empty_slabs

commit b6d4af872f9be4b0e0ddcc21da66f5d382c439bd
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 03:03:19 2018 -0400

    move libdivide.h to third_party/libdivide.h

commit 99fcddc22386fe4554b6c660229ada676c793843
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 30 01:16:58 2018 -0400

    use much faster get_random_{type}_uniform approach

commit 1c181557c71f4d68de4686d904ccaaa9f156fc79
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 15:20:56 2018 -0400

    add -fno-plt as an optimization

commit 6f9de3e667ed0c5bc6eb152e95d750c7b7fb26f8
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 15:13:53 2018 -0400

    add inline hint to get_size_info

commit e85c69a0a4b7a067da5c7930505929abffb5f041
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 15:06:49 2018 -0400

    fix builds with prefix

commit becadc57a55cf2d4431ac1bec987ed125c8207b1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 13:58:58 2018 -0400

    get rid of unused MIN_ALIGN definition

commit 2684a98eabcf4a668a98b23b18babf9ed6d43c6c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 13:43:35 2018 -0400

    add initial malloc_object_size extensions

commit 00b2613e1606c4d46dc1510ad1a53b3a75ee50cf
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 13:04:52 2018 -0400

    add mmap MAP_FIXED wrapper for dropping slabs

commit 0e2f3d101521453db8c9fdbfea881982037cce27
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 10:59:37 2018 -0400

    sanity check page size at runtime

commit d779d41721b9469c41f3ff043cfedb074e701b8b
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 10:52:10 2018 -0400

    wrap more memory mapping implementation details

commit 1cb28531a87ebe7c6ae862dc17bde7ce45db5449
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 10:43:54 2018 -0400

    add wrapper for mremap with sanity check

commit 5bc6820c24d7fb63f969be4447e7fbebc0673797
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 03:24:28 2018 -0400

    rely on mmap rounding to page size when possible

commit 58d929c0f06081d89ba93a6307b8f9fbf32752cc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Wed Aug 29 00:53:12 2018 -0400

    split out low-level memory mapping wrappers

commit 8b42e8c3d68e3d1e08dc3709145960c6e536bf48
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 28 22:46:20 2018 -0400

    make sure errno is always set on failure

commit 66aa98dbd91119a99ed5a71831302477568e3c2d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 28 22:41:18 2018 -0400

    sanity-check mmap errno on failure too

commit 705b6a4f8daa4008fc547edc0b258383e190da0d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 28 22:21:38 2018 -0400

    make non-out-of-memory mprotect errors fatal

commit 19c46d16f13e2ac1218d3f61a2d2e8382b462280
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 28 21:31:20 2018 -0400

    check pthread_atfork return value

commit 0e2bc8a1cfff8c9dedef823f59316be2ecd86c2c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 28 11:44:23 2018 -0400

    make sure RELRO is enabled on every toolchain

commit e72674e358959524411a1613bb73b4d4110ea877
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 28 11:13:17 2018 -0400

    detect missing symbols when linking

commit 803811a6ac703b2693499f5f03729dce16617548
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 28 09:49:18 2018 -0400

    add support for using mremap

commit 718bf82f966e6963fc214792e36be38d4bb47bc2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 27 09:29:14 2018 -0400

    add inline hints for slab_allocate and slab_free

commit 33f862ec1949659a5b629f14f72d676cf4e4f02e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 27 09:23:35 2018 -0400

    add inline hints for init and enforce_init

commit 67b9608ccf87aa69cccd11a6960874ef60b48ced
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 27 09:21:42 2018 -0400

    avoid duplicated init code calculating slab size

commit eec85b0c8cffc89c25704d0b87e71e7f07308d15
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 27 07:49:50 2018 -0400

    add chosen libdivide license (Boost) to CREDITS

commit c7b24f63f16d2a00c7fbae496ab497f8d2bc0490
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 27 06:57:44 2018 -0400

    use libdivide for substantially faster division

commit 63b0c39343487392f8a5a29baa0a78d869833554
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 27 05:16:47 2018 -0400

    reorder size_class struct for better performance

commit b424c957372605fa2fc2c83097ae30bbb2ac3fca
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Mon Aug 27 01:14:15 2018 -0400

    clarify memory is zero on init without more writes

commit 02db36c4bb25cb48ada3f2290e95bfd642fb9937
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 07:27:19 2018 -0400

    update CREDITS with ChaCha8 implementation

commit 1b3d485e87573867f5368552c268b19bc40b79b5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 07:19:58 2018 -0400

    clarify that the slab design isn't like jemalloc

commit c97bbc141cd225d7a9afade2ffa2ccdc11438e66
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 07:11:22 2018 -0400

    add missing word

commit f793a2719f586a76f1b08642aa3e980ab0158a91
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 06:23:24 2018 -0400

    add some basic initial documentation to the README

commit c60fbfb0295af0640fda0371af17a9466aaba323
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 06:21:09 2018 -0400

    output markdown table from calculate_waste

commit 497f71ac652d8697b1fa0b28e92cefbd21b150ef
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 04:51:38 2018 -0400

    reorder offset test output

commit 14ca7d7c3f9893b01ef7302a8360fb74306b0084
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 04:42:01 2018 -0400

    randomize large allocation guard size

commit a13a45a17da2d540fe3f7d96c4e639f53ce4fc53
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 04:37:43 2018 -0400

    hold regions_lock in alloc_aligned

commit bec20a39cf2e5cd85df668eb1a3b5f52496414cb
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 03:15:13 2018 -0400

    add offset test

commit 700e06c2db0768adb6d26697836db86ebab762fe
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sun Aug 26 00:02:35 2018 -0400

    manually specialize the CSPRNG cache

commit c41e659383141da2adbadcf8d92f1dbee83ae269
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 23:00:00 2018 -0400

    use ChaCha8-based CSPRNG

commit 2b7c9362bbf0370b4f819d244375844946391c6a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 18:32:44 2018 -0400

    consume fewer random bytes for slab randomization

commit c5d76179a5cccae5b75dd1b1f2c4037b362a9a35
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 18:04:55 2018 -0400

    improve interaction of slot rand with slot mask

commit 173dd6e7a5636a098e0820ea2ce4a999781a6a61
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 18:02:13 2018 -0400

    randomize slot selection for empty slabs too

commit c335c43dd78ce915f7639bad6bb0df77d5ebf6a5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 16:41:07 2018 -0400

    simplify slab out-of-memory error handling

commit 7bcfa3f08be436a4b7ff34cf96c2dd12e6d0680c
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 15:43:50 2018 -0400

    tune slab metadata allocation

commit 4777ee0c8591986380f8e6c161f15536c3d0af21
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 15:21:50 2018 -0400

    special case division for page size slabs

commit ec78add6ab1db373be9a8a9f7e22ef4bfd9bc716
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 03:09:09 2018 -0400

    define ffzl utility function

commit f08d4d31dbe4404a0ab74cc405f2bd24a883cb57
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 03:02:39 2018 -0400

    randomize slab slot choice

commit 965c3202b472743406f1943f031ba2bcdddfcb41
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 02:48:47 2018 -0400

    finish implementation of zero byte size class

commit f97a0ef8b1dd2442d7dedab4c8a0ece649264084
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 01:09:15 2018 -0400

    use a more appropriate type for masked bitmaps

commit f3c850250964823ede4efd88f891ee0dcb9043a9
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Sat Aug 25 00:21:02 2018 -0400

    add CSPRNGs for regions and slabs

commit 510291646bcca64451e70dd714cc59d7b022bacc
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 18:58:55 2018 -0400

    document minimum versions for dependencies

commit 71dde7c4f832d34f44015285e01b1b1e3fea868e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 18:44:49 2018 -0400

    provide getrandom wrapper to support glibc < 2.25
    
    Debian stretch (currently stable) only has glibc 2.24...

commit 35c9e6f16d670f608c68db7304f6eed408eb6186
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 05:53:17 2018 -0400

    add delayed double free tests

commit aaa4eeca4d57efe6b0a21a10df5ca7833cb8b6ca
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 05:25:25 2018 -0400

    add a clean target for the memory corruption tests

commit 805bdc60879e0f5ca2054e74b6eeab255de76fbd
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 05:18:20 2018 -0400

    add an extra sanity check for unallocated metadata

commit bde8c3c29b19a658980fc6e365a667ffd04d670d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 05:09:33 2018 -0400

    add another test for invalid small region frees

commit fe85116891b3317e1e99a8ee534467bae5eea77e
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 05:02:00 2018 -0400

    add uninitialized allocator tests

commit 2d168b0516f7f1a70f8dba262d2ea8bbd4018b95
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 04:51:52 2018 -0400

    check for double free slightly earlier

commit 0a79e82474c0ce7f2b0d2beeb76299369ffcf8a5
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 04:45:48 2018 -0400

    add basic invalid free tests

commit 97b693d8620daa98d7f2262fc6291aeee051b9ef
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 04:07:46 2018 -0400

    stop treating guard size as a constant

commit 83dabbd8faa477a7246a220c9a96ff0bf24404db
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 03:52:01 2018 -0400

    fix handling of random bases for class regions

commit 0d51459dc928b90d63933380663a70c8c2b4b8ea
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 03:22:52 2018 -0400

    add a special memory protected 0 byte size class

commit 27ac1e21bcf3a89e6ddf913d993125da193f00cd
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 03:09:23 2018 -0400

    add initial simple memory corruption tests

commit 7a86b67778c4cbedbb4cbd0bd7da983ea82b10d0
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 02:55:53 2018 -0400

    add unaligned free check for small allocations

commit 2aee424b7b32dd27059730e427164b8f63bf5df3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Fri Aug 24 02:09:20 2018 -0400

    fix inconsistent whitespace

commit a874a61099337dad11920a9ea60ebdf1dd8acee1
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 17:57:09 2018 -0400

    adjust slot count for 12288 byte size class

commit 127f110126824c286d90f93d2e1cec3f411e4388
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 17:56:17 2018 -0400

    adjust slot count for 10240 byte size class

commit b7b353a54e7d6d5c2ca292670fea392c32b6d18d
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 17:53:55 2018 -0400

    print out the calculated slab sizes too

commit c59c97c65b5ad7e152b722bdb984aa0adbc2ad99
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 17:53:10 2018 -0400

    adjust slot count for 48 byte size class

commit 56e4c7e042515d2f5d476a1d01cc5a3ee0341cc3
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 17:42:17 2018 -0400

    adjust slot count for 224 byte size class

commit 5a1a76f94e266820de6fbdab06883738ced12f14
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 17:39:32 2018 -0400

    calculate internal slab fragmentation from slots

commit 5bdf94da4a817c0b6a6e4e5548e4be7f88af7b2a
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 17:29:42 2018 -0400

    calculate internal fragmentation for size classes

commit 4aa0fab4f424fb5ccd7571c8968f45a2af5ea534
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 17:15:50 2018 -0400

    avoid deadlocks after forking threaded processes

commit daa44905eed56f240d7ec685a8bc229895b20ec2
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Thu Aug 23 16:30:44 2018 -0400

    implement a cache for the CSPRNG

commit 70d61b6662a896b420f674fd31c6c9825772b150
Author: Daniel Micay <danielmicay@gmail.com>
Date:   Tue Aug 21 15:23:22 2018 -0400

    initial commit
